#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20050813

#define YYEMPTY (-1)
#define yyclearin    (yychar = YYEMPTY)
#define yyerrok      (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

extern int yyparse(void);

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 2 "gram.y"
/* $Header: /local/src/CVS/nickle/gram.y,v 1.146 2005-10-02 18:30:19 bart Exp $ */

/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 1 shift/reduce conflict and 4 reduce/reduce:
 * 
 * 2 reduce/reduce conflicts on:
 *
 *	    *int . func 
 *	    **int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 * 2 reduce/reduce conflicts on:
 *
 *	   &int . func
 *	   &&int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers.
 *	(Of course, you can always enclose an assignment in parens.)
 *      (I can't see any obvious way to use operator precedence to
 *      get rid of this: seems like you'd need to duplicate simpleexpr
 *      with different precedence. --BCM)
 *
 */
int ignorenl;
int notCommand;
int seeComment;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static Expr *
ParseCanonFor (Expr *expr);

static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);

#line 72 "gram.y"
typedef union {
    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;
} YYSTYPE;
#line 112 "gram.c"
#define VAR 257
#define EXPR 258
#define ARRAY 259
#define STRUCT 260
#define UNION 261
#define ENUM 262
#define COMP 263
#define HASH 264
#define SEMI 265
#define MOD 266
#define OC 267
#define CC 268
#define DOLLAR 269
#define DOTDOTDOT 270
#define ENDFILE 271
#define GLOBAL 272
#define AUTO 273
#define STATIC 274
#define CONST 275
#define POLY 276
#define INTEGER 277
#define NATURAL 278
#define RATIONAL 279
#define REAL 280
#define STRING 281
#define FOREIGN 282
#define FILET 283
#define MUTEX 284
#define SEMAPHORE 285
#define CONTINUATION 286
#define THREAD 287
#define VOID 288
#define BOOL 289
#define FUNCTION 290
#define FUNC 291
#define EXCEPTION 292
#define RAISE 293
#define TYPEDEF 294
#define IMPORT 295
#define NEW 296
#define ANONINIT 297
#define NAMESPACE 298
#define PUBLIC 299
#define PROTECTED 300
#define EXTEND 301
#define WHILE 302
#define DO 303
#define FOR 304
#define SWITCH 305
#define BREAK 306
#define CONTINUE 307
#define RETURNTOK 308
#define FORK 309
#define CASE 310
#define DEFAULT 311
#define TWIXT 312
#define NAME 313
#define TYPENAME 314
#define NAMESPACENAME 315
#define COMMAND 316
#define NAMECOMMAND 317
#define TEN_NUM 318
#define OCTAL0_NUM 319
#define OCTAL_NUM 320
#define BINARY_NUM 321
#define HEX_NUM 322
#define TEN_FLOAT 323
#define OCTAL0_FLOAT 324
#define OCTAL_FLOAT 325
#define BINARY_FLOAT 326
#define HEX_FLOAT 327
#define CHAR_CONST 328
#define STRING_CONST 329
#define POLY_CONST 330
#define THREAD_CONST 331
#define COMMENT_CONST 332
#define VOIDVAL 333
#define BOOLVAL 334
#define DARROW 335
#define POUND 336
#define COMMA 337
#define ASSIGN 338
#define ASSIGNPLUS 339
#define ASSIGNMINUS 340
#define ASSIGNTIMES 341
#define ASSIGNDIVIDE 342
#define ASSIGNDIV 343
#define ASSIGNMOD 344
#define ASSIGNPOW 345
#define ASSIGNSHIFTL 346
#define ASSIGNSHIFTR 347
#define ASSIGNLXOR 348
#define ASSIGNLAND 349
#define ASSIGNLOR 350
#define QUEST 351
#define COLON 352
#define OR 353
#define AND 354
#define LOR 355
#define LXOR 356
#define LAND 357
#define EQ 358
#define NE 359
#define LT 360
#define GT 361
#define LE 362
#define GE 363
#define SHIFTL 364
#define SHIFTR 365
#define PLUS 366
#define MINUS 367
#define TIMES 368
#define DIVIDE 369
#define DIV 370
#define POW 371
#define STARSTAR 372
#define POW2 373
#define POW3 374
#define UNIONCAST 375
#define UMINUS 376
#define BANG 377
#define FACT 378
#define LNOT 379
#define INC 380
#define DEC 381
#define STAR 382
#define AMPER 383
#define THREADID 384
#define OS 385
#define CS 386
#define DOT 387
#define ARROW 388
#define STAROS 389
#define CALL 390
#define OP 391
#define CP 392
#define POINTER 393
#define COLONCOLON 394
#define IF 395
#define TRY 396
#define NONL 397
#define ELSE 398
#define CATCH 399
#define NL 400
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   96,   96,   99,   99,   99,  100,  101,   98,
  102,  103,  103,  104,  104,  105,  105,   97,   97,   97,
   97,   97,   97,   97,    3,    3,    5,    5,    4,    7,
    7,    7,    6,    6,   27,   27,    1,    1,    2,    2,
   28,   28,   60,   60,  106,  107,    8,  108,  109,   14,
   14,   17,   17,   15,   15,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,  111,   16,   16,   16,   16,   70,   70,   19,   19,
   18,   12,   12,   13,    9,    9,  112,   10,   20,   20,
  110,  110,  113,   81,   82,   82,   21,   22,   22,   23,
   23,   24,   25,   25,   26,   26,   37,   37,   33,   33,
   35,   35,   40,   40,   34,   34,   36,   43,   38,   39,
   39,   39,   41,   41,   41,   42,   42,   42,   46,   46,
   46,   46,   46,   46,   45,   45,   45,   45,   45,   47,
   47,   47,   47,   47,   47,   44,   44,   51,   51,   51,
   51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
   48,   48,   49,   49,   50,   50,   52,   52,   53,   53,
   54,   54,   56,   56,   55,   55,   55,   55,   57,   57,
   58,   58,   59,   59,   61,   61,   62,   62,   63,   63,
   66,   64,   64,   65,   65,   67,   67,   68,   68,   69,
   69,   71,   71,   77,   77,   72,   72,   73,   73,   75,
   75,   76,   76,   11,  114,   11,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   79,   79,   78,   78,
   78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
   78,   80,   80,   80,   80,   80,   83,   83,   83,   84,
   84,   29,   29,   30,   30,   31,   32,   85,   85,   86,
   86,   87,   87,   87,   88,   89,   89,   90,   90,   91,
   91,   92,   93,   93,   94,   94,   95,   95,   95,   95,
};
short yylen[] = {                                         2,
    2,    0,    1,    3,    1,    1,    1,    0,    0,    0,
    0,    1,    0,    1,    0,    1,    0,    4,    6,    4,
    6,    6,    1,    1,    1,    0,    3,    1,    2,    1,
    1,    1,    3,    0,    2,    1,    2,    1,    1,    3,
    3,    2,    1,    1,    0,    0,    3,    2,    2,    2,
    0,    7,    9,    1,    1,    3,    9,   10,    9,    9,
   10,    2,    2,    3,    2,    1,    4,   10,    6,    6,
    7,    0,    9,    6,    2,   11,    3,    1,    1,    3,
    4,    2,    0,    7,    1,    1,    0,    2,    1,    4,
    1,    1,    0,    2,    1,    0,    3,    2,    0,    4,
    3,    3,    2,    0,    7,    3,    1,    0,    3,    1,
    3,    1,    1,    1,    4,    2,    1,    1,    4,    3,
    4,    4,    2,    2,    0,    4,    3,    2,    2,    4,
    4,    4,    4,    0,    2,    2,    2,    2,    2,    1,
    4,    4,    4,    3,    1,    1,    0,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    0,    3,    1,    3,    1,    3,    1,    4,    0,
    4,    0,    1,    0,    1,    1,    1,    1,    1,    0,
    1,    1,    1,    1,    3,    2,    3,    2,    2,    1,
    3,    2,    1,    3,    2,    2,    1,    1,    0,    1,
    0,    1,    2,    1,    3,    1,    0,    3,    1,    1,
    0,    3,    2,    3,    0,    2,    3,    7,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    3,    3,    3,    3,    3,    3,    3,    2,
    2,    3,    3,    5,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    6,    8,    8,    8,    3,    6,    2,    1,    3,
    3,    4,    4,    4,    3,    3,    1,    0,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    0,    5,
    9,    2,    1,    3,    1,    1,    0,    3,    1,    1,
    1,    1,    2,    0,    4,    3,    1,    3,    2,    1,
    1,    4,    3,    1,    3,    3,    1,    1,    1,    2,
};
short yydefred[] = {                                      2,
    0,   10,   24,   23,    1,    3,    0,    0,    0,    0,
    0,   66,    0,   45,    0,  175,  176,  177,  178,  148,
  149,  150,  151,  152,  160,  153,  154,  155,  156,  157,
  158,  159,    8,    0,  181,  182,  184,    8,    8,    8,
    8,    0,    0,    0,    0,    8,   43,   36,    0,    0,
    0,  257,  259,  258,  260,  261,  262,  264,  263,  265,
  266,  267,  268,  269,  270,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  279,    0,    8,    8,  256,
   55,   10,   54,   46,    9,  145,    0,   93,   45,    0,
    0,    0,    0,  140,    0,    0,    0,    0,   38,    0,
    0,    0,    0,    0,    6,    7,    5,    4,    0,    0,
    0,  302,  304,  303,  305,  306,  219,   48,  278,  287,
    0,    0,    0,   45,   45,   45,   45,   62,   63,    0,
    0,    0,    0,    0,  200,    0,    0,   45,   42,   10,
  206,    0,   10,    0,   25,    0,  138,    0,  139,    0,
    0,  136,    0,  137,    0,    0,    0,    0,    0,  271,
    0,    0,    0,    0,   45,    0,    0,    9,   75,   35,
    0,   37,    0,    0,    8,    0,    0,  203,    0,   45,
    0,   12,  128,    0,    0,  135,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  146,    8,    8,    8,  173,
    0,    8,   65,    0,    0,    0,  301,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  240,
  241,  227,  229,  231,    0,    0,    0,    0,    0,    0,
    0,   46,    0,    0,    8,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  117,   64,    0,
    0,    0,    0,   34,   30,   32,   31,    0,    0,    0,
    0,    0,    0,  281,    0,    0,  280,    0,    0,   79,
   83,   20,   56,   41,   86,   46,   85,    0,   95,   94,
    0,    0,    0,  120,    0,    0,    0,  276,  166,    0,
    0,    0,    0,    0,  186,    0,    0,    0,  129,  138,
  139,  136,  137,    0,    0,  127,    0,    0,    0,    0,
    0,   10,   18,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  285,  286,    0,    0,    0,
  210,    0,    0,    0,   47,   50,   45,    0,  141,    0,
  142,    0,  143,  122,    0,    0,    0,    0,    0,    0,
   14,    0,  208,    0,   27,   33,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   67,   89,   88,    0,
  119,    0,    0,  192,    0,  121,    0,    0,  337,  339,
  338,  124,  118,    0,    8,   93,    0,    0,    0,    0,
    0,  189,  185,  198,    0,  188,  144,   45,  114,    0,
    0,    0,    0,    0,    0,  126,   44,   72,    0,    0,
  283,  282,    0,  213,  284,   49,    0,    0,    0,  109,
    0,    0,    0,    0,    0,    0,    0,   21,   22,   45,
  163,   45,   45,  167,    0,   46,    0,   80,    0,   82,
    0,  196,    0,  195,  340,    0,    0,    0,    0,    0,
  319,    0,  327,    0,  334,  321,  115,    0,    0,  133,
  130,  165,  131,  132,  187,    0,    9,    0,  113,    0,
    0,    9,    0,   19,    0,  212,    0,  169,  171,   69,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  272,    0,   45,    0,  194,    0,    0,  329,  331,    0,
    0,    0,    0,    0,    0,    0,    0,  191,   46,    0,
    0,   46,   70,  111,    9,   40,   74,    0,    0,   46,
    0,   77,   46,   46,    0,    0,    0,   46,  322,    0,
   46,    0,   46,  307,    0,    0,   90,    0,  336,  316,
  317,    0,  328,    0,  318,    0,    0,  326,  325,    0,
  333,  332,  218,    0,  216,   93,   71,    0,    0,    9,
   46,    9,    9,    0,    0,   46,    0,    0,  323,  275,
  273,  308,  274,    0,   93,    0,    0,  310,    0,    0,
    9,   46,    0,   57,    9,   59,   60,    0,    0,   97,
   98,   46,   53,    0,    0,  314,    9,   73,    9,   45,
    0,   46,    0,   58,    0,  101,    9,   46,    0,  313,
   46,   68,   61,    0,    0,  102,  103,  100,   76,   84,
  312,    0,    0,  106,  311,  107,    0,    0,   46,  105,
};
short yydgoto[] = {                                       1,
   80,  435,  143,  144,  145,  146,  278,   81,  296,  297,
  539,  396,  470,  252,  253,   83,   84,   85,  291,  399,
  554,  596,  597,  612,  632,  633,   86,   87,  641,  571,
  572,  606,  261,  178,  431,  179,  657,   88,   89,  432,
  306,   90,  414,   91,  136,  186,   93,  311,  281,  313,
   94,  282,  257,  259,   95,  201,   96,   97,   98,   99,
  187,  317,  318,  301,  404,  416,  405,  426,  454,  455,
  254,  140,  141,  101,  360,  361,  102,  250,  119,  117,
  173,  300,  563,  409,  480,  481,  558,  410,  482,  483,
  528,  411,  484,  485,  486,    5,    6,    8,  108,  302,
  169,    7,  183,  382,  533,  118,  364,  103,  365,  104,
  503,  298,  174,  541,
};
short yysindex[] = {                                      0,
 -247,    0,    0,    0,    0,    0, 1228, -213, -241, -231,
 -186,    0,  131,    0,  131,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   55,    0,    0,    0,    0,    0,    0,
    0,  -60,  -48, 5079, 6231,    0,    0,    0, -260, 6231,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 6231, 6231, 6231, 6231, 6231,
 6231, 6231, 6231, 6231, -139,    0, 4951,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   49,    0,    0,  -90,
 -116,  -89,  -94,    0, 6385,  200,  212,    3,    0, -223,
 6642,  -24, 1360,   13,    0,    0,    0,    0, 6385, 6385,
   19,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   69,    7,   70,    0,    0,    0,    0,    0,    0, -231,
 -186,   93,  212,  145,    0,   29, 2122,    0,    0,    0,
    0, 2010,    0,  103,    0,   80,    0,   20,    0,   20,
   20,    0,   20,    0,   20,   20,   20,   20,   20,    0,
 5591,   62,  -93,   66,    0, 1492,   72,    0,    0,    0,
   95,    0,  163,  147,    0,  184,  122,    0,  178,    0,
  205,    0,    0, 5719, 3929,    0,  -94, -260, 6385, 6385,
 6385, 6385, 6385, -225,   72,    0,    0,    0,    0,    0,
 6385,    0,    0, 5079,  124, 6231,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 6231,
 6231, 6231, 6231, 6231, 6231, 6231, 6231, 6231, 6231, 6231,
 6231, 6231, 6231, 6231, 6231, 6231, 6231, 6231, 6231,    0,
    0,    0,    0,    0, 6231,  214,  215, 6231, 6231, 6231,
 6231,    0, 1360,  260,    0,   19,  264,   19,  265,  197,
  272,  151, 6231,  153, 1360,  154,  155,    0,    0,  156,
  273, 6231,  273,    0,    0,    0,    0,  162, 6231,  -29,
 -271,  172, 6424,    0,  236,    0,    0,  169, 1360,    0,
    0,    0,    0,    0,    0,    0,    0,  294,    0,    0,
  171, 6385,  173,    0, 5847,  231,  179,    0,    0,   50,
  185,  237,  -62,  187,    0,  271,  191, -149,    0,    0,
    0,    0,    0,  194,   95,    0,  279, 6344,   55,   72,
  114,    0,    0,  234, 6478, 2231, 2340, 2449, 2558, 2667,
  476,  476,  613,  613,  613,  613,  768,  768,  360,  360,
  234,  234,  234,  234,  207,    0,    0,  208, 1882,  204,
    0, 6642, 6642,  334,    0,    0,    0,  344,    0,  345,
    0,   19,    0,    0,  221, 5079,  314, 5079, 5079, 5079,
    0,  217,    0,  224,    0,    0,  228,  259,  238,  239,
 6231,  241,  369, 5079,  372,  242,    0,    0,    0,  299,
    0,  330,    0,    0,  -64,    0, 5207, 6642,    0,    0,
    0,    0,    0,   93,    0,    0,  -94,  -94,  375,  -94,
  -94,    0,    0,    0, 6385,    0,    0,    0,    0,    0,
  381,  310,   35,  311,  385,    0,    0,    0,  252, 6231,
    0,    0, 6231,    0,    0,    0,  262, 6385, 6385,    0,
  389,  263,  266,  391,  267,  268,  393,    0,    0,    0,
    0,    0,    0,    0, 6231,    0,  269,    0,   55,    0,
 6231,    0, 6385,    0,    0,  324, 5847, -139, 6533,  326,
    0,  327,    0,  332,    0,    0,    0,  275,    0,    0,
    0,    0,    0,    0,    0,  297,    0,   35,    0,  424,
   55,    0,  423,    0, 2122,    0, 5079,    0,    0,    0,
 1360, 5079, 5079, 1360,  294, 5079,  425,  426,  427,   20,
    0, 1360,    0, 1625,    0, 5847, 6642,    0,    0,  378,
 5847, 5847,  428, 5975,  429,  383,  452,    0,    0,  384,
  294,    0,    0,    0,    0,    0,    0, 1360,  331,    0,
  333,    0,    0,    0,  112,  339, 5335,    0,    0, 6103,
    0, 5463,    0,    0,  328,  179,    0, 6642,    0,    0,
    0,  387,    0, 6642,    0,  468, 6533,    0,    0,  324,
    0,    0,    0, 6231,    0,    0,    0,  470,  294,    0,
    0,    0,    0, 5079,  392,    0,  112, 1360,    0,    0,
    0,    0,    0, 1360,    0,  366,  378,    0, 6642,  481,
    0,    0,  192,    0,    0,    0,    0,  401, 1360,    0,
    0,    0,    0,  294, -218,    0,    0,    0,    0,    0,
  402,    0,  192,    0, 1360,    0,    0,    0, 5847,    0,
    0,    0,    0,  442, 1360,    0,    0,    0,    0,    0,
    0,  490,  446,    0,    0,    0,  408, 1360,    0,    0,
};
short yyrindex[] = {                                      0,
 1096,    0,    0,    0,    0,    0,   83,    0,    0,  460,
  474,    0,    0,    0, 1562,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -234,  507,    0,    0,    0, 1690, -181,
 -220,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  507,  507,  507,  507,  507,
  507,  507,  507,  507,    0,    0,  507,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   25,  143,    0, -278,  533,  919,    0,    0,  432,
 -254, -185,  284,    0,    0,    0,    0,    0,   15,   32,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  964,    0,    0,  542,  335,    0,    0,    0,
    0, -251,    0, -209,    0,    0,    0, 2074,    0, 2184,
 2294,    0, 2404,    0, 2514, 2624, 2734, 2844, 2954,    0,
  507,    0, -168,    0,    0,   83,  797,    0,    0,    0,
 1690,    0, -203,    9,    0,    0, -232,    0, -245,    0,
    0,    0,    0, -183,    0,    0,  143,    0,    0,    0,
    0,    0,    0,    0,   -5,    0,    0,    0,    0,    0,
 -278,    0,    0,  507,    0,  507,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  507,
  507,  507,  507,  507,  507,  507,  507,  507,  507,  507,
  507,  507,  507,  507,  507,  507,  507,  507,  507,    0,
    0,    0,    0,    0,  507,    0,    0,  507, -252,  507,
  507,    0,  944,    0,    0,    0,    0,    0,    0,   85,
    0,    0, -250,    0,   83,    0,    0,    0,    0,    0,
  447,  507,  447,    0,    0,    0,    0, -204, -119,  542,
    0,    0,  465,    0,    0,   39,    0,    0,  284,    0,
    0,    0,    0,    0,    0,    0,    0,  514,    0,    0,
    0, -283,    0,    0,  507,  -56,    0,    0,    0,  542,
    0,  473,    0,    0,    0, -127,    0,  462,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   -5,
    0,    0,    0, 3174,    0,  364, 4767, 4746, 4654, 4631,
 4508, 4534, 4112, 4211, 4310, 4409, 3910, 4011, 3704, 3807,
 3280, 3386, 3492, 3598,    0,    0,    0,    0,  462,    0,
    0, -236, -179,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  507,    0, -244,  507, -234,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  507, 6588,    0,  507,    0,  501,    0,    0,    0,    0,
    0,    0,   22,    0,  462,    0,  507,  -73,    0,    0,
    0,    0,    0,    0,    0,    0,  143,  143,    0,  143,
  143,    0,    0,    0,    0,    0,    0,    0,    0,   47,
    0,  595,    0,  597,    0,    0,    0,    0,    0,  507,
    0,    0,  507,    0,    0,    0,    0,   15,   32,    0,
    0,    0,    0,  478,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  507,    0,    0,    0,    0,    0,
  507,    0,  553,    0,    0, 1752,  507,  558, -201,  220,
    0,  604,    0,  604,    0,    0,    0,    0, -140,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 4857,    0,  507,    0,    0,    0,
   83,  507, -244,   83,    0, -248, 1818,    0, 1946, 3064,
    0,   83,    0,    0,    0,  507, -156,    0,    0,    0,
  507,   63,  606,   34,    0,  607,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  284,    0,    0,
    0,    0,    0,    0,  608,    0,  507,    0,    0,  507,
    0,  507,    0,    0,  642,    0,    0, -129,    0,    0,
    0,  491,    0, -201,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  507,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  507,    0,    0,  608,   83,    0,    0,
    0,    0,    0,   83,    0,    0,    0,    0,  -66,    0,
    0,    0,  615,    0,    0,    0,    0,    0,  944,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  615,    0,  944,    0,    0,    0,  507,    0,
    0,    0,    0,    0,  944,    0,    0,    0,    0,    0,
    0,    0,  532,    0,    0,    0,    0,  944,    0,    0,
};
short yygindex[] = {                                      0,
  -26,  386,    0,    0,  611,    0,    0,  -74,    0,    0,
    0,    0,    0, -243,   -3,  723,    0,    0,    0,    0,
    0,  293,    0,    0,  258,    0,    0,  270,    0,  286,
    0,    0,  -63,  480, -211,    0,    0,    0,    0,    0,
    0,  -39,    0,  -82,   -7, -169,    0,    0,  711,    0,
    0, -131,  457,  451,  181,    0,    0,   41,    0,  -72,
  410,  487,    0,  505,  466,  406,    0, -357,  -38,  461,
   10,  675,  701,    5,    0,  541,    0,    0,    0,  973,
 -415,    0,    0,    2,    0, -513,    0,  472,    0,  458,
  464,    0,    0,  455, -265,    0,    0,  -75,    0,   91,
 -146,    0, -151,  724,   28,   36,   27, -492, -315,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 7033
short yytable[] = {                                      92,
  489,  444,  162,   82,  132,  134,  167,  122,    2,  366,
  204,  147,  195,  209,  172,  292,  100,  319,  575,  125,
  201,  293,  555,    3,  205,  109,  256,  258,  217,  147,
  201,  217,  117,  217,  147,  110,   92,  132,  147,  412,
  147,  203,  147,  326,   26,  395,  147,  474,   14,  137,
  172,  105,  314,  135,  142,   28,  147,  106,  147,  149,
   29,  152,  154,   87,  271,  388,  320,  273,  320,  163,
  148,  150,  151,  153,  155,  156,  157,  158,  159,  202,
  111,  204,  204,  207,  133,  205,  164,  196,  170,  325,
  125,  125,   34,   34,   34,   92,  613,  204,  217,  217,
  217,  196,  196,  117,  117,  117,  125,  147,  193,  147,
  168,  330,  204,  355,  389,  217,  358,  133,  330,  639,
  424,  147,  146,  121,  175,  651,  215,  466,  124,  125,
  126,  127,   29,  139,   87,  320,  138,  204,  335,  211,
  209,  207,  190,  201,   13,  204,  125,  201,  209,  217,
  202,  400,    4,  280,  125,  217,  205,  205,   92,  264,
  265,  266,  267,  217,  132,  283,  202,  117,  165,  166,
  610,  147,  205,  270,  180,  576,  310,  316,  436,   26,
  330,  320,  321,  322,  323,  324,  107,  425,  283,  624,
   28,  123,  368,  196,  370,   29,   92,    9,  214,  176,
  288,  214,  162,  214,  128,  424,  202,  335,  116,  190,
  334,  529,  205,  332,  202,  307,  129,  164,  207,  402,
  205,  500,  177,  398,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  133,   92,  160,  490,  491,  283,
  493,  494,  283,  359,  362,  363,  439,   92,  438,  464,
  569,  377,  123,  123,  190,  529,  164,  142,  214,  214,
  214,  152,  473,   96,  419,   96,  142,  200,  123,  116,
  620,   92,  170,  153,   13,  214,  544,  327,  328,  329,
  184,  197,  331,  285,  403,  116,  185,  181,  286,  172,
  202,   16,  434,  123,  588,   45,  182,   13,  450,  408,
  182,  113,  251,  200,   13,  146,  646,  255,  123,  214,
  433,  393,  397,  420,  147,  214,  123,  147,  144,  144,
   16,  260,   16,  214,  146,  116,  132,   13,  132,  132,
  132,  457,  540,  116,  147,  367,   96,  429,  499,  110,
  543,  144,  110,  147,  132,  547,  387,  181,  197,   36,
   36,   47,  170,  171,  194,  256,  258,   47,   92,   49,
   92,   92,   92,  147,  180,  636,  180,  180,  194,  194,
  180,  262,   47,  113,  171,  452,   92,  135,  456,  135,
  402,  648,  275,  276,  277,  283,  242,  263,  587,  243,
  244,  654,  447,  467,  245,  268,  246,  247,  248,  269,
  249,  479,  134,  197,  659,  181,  133,  316,  133,  133,
  133,  594,  595,  144,  144,  144,   47,  295,  437,  144,
  144,   36,  134,  134,  133,  417,  181,   36,  144,  274,
  196,  196,  523,  614,  505,  616,  617,  359,  112,  113,
  114,  115,  116,  284,  194,  134,  134,  287,  194,  194,
  194,  194,  194,  496,  628,  403,  585,  132,  634,  520,
  194,  182,  132,  132,  434,  524,  132,  556,  299,  134,
  642,  527,  643,   16,   17,   18,   19,   17,  294,   17,
  649,  197,  521,  198,  199,  517,  303,  518,  519,   92,
   81,  630,  631,   92,   92,   92,   92,  550,   92,  535,
  553,  537,  304,  530,   92,  305,  549,  308,  565,  561,
  564,  551,  135,  333,  203,  135,  356,  357,  134,  134,
  568,  369,  371,  372,  134,  527,  574,  381,  577,  373,
   92,  374,  134,  376,  378,  379,  380,  133,  392,  638,
  640,   51,  133,  133,  132,  386,  133,  390,  566,  394,
   14,  577,  401,  406,  574,  583,  574,  413,  586,  415,
  418,  194,  421,  388,  147,  180,  590,  180,  180,  592,
  593,  180,  423,  422,  600,  427,   92,  601,  609,  603,
   92,  428,  441,  442,  622,  445,   92,  194,  123,  232,
  623,  446,  232,  618,  232,  239,  240,  241,  448,  449,
  242,   92,  451,  243,  244,  453,  458,  615,  245,  460,
  246,  247,  248,  459,  249,  206,  461,   92,  249,  462,
  463,  249,  465,  249,  133,  407,  471,   92,  629,  468,
  469,   52,  472,  574,  492,  497,  498,  501,  637,  502,
   92,  504,  507,  510,  511,  513,  512,  516,  514,  515,
  522,  526,  532,  534,  650,  644,  538,  652,  536,  232,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,  660,  232,  185,  545,  548,
  570,  557,  560,  562,  194,  580,  579,  424,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  194,  194,  582,
  232,  584,  589,  607,  591,  604,  232,  236,  237,  238,
  598,  239,  240,  241,  232,  608,  242,  611,  123,  243,
  244,  206,  194,  619,  245,  627,  246,  247,  248,  249,
  249,  625,  635,  645,  653,  249,   81,  655,  656,  658,
   81,   81,   81,  249,   91,   81,   81,   81,   81,   81,
  123,   81,   81,   81,   81,   81,   81,   81,   92,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   13,  147,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
  183,   10,  146,   81,   81,  228,  229,  230,  231,  232,
  233,  234,  235,  236,  237,  238,   15,  239,  240,  241,
  168,    9,  242,  199,   81,  243,  244,   81,  161,  112,
  245,   39,  246,  247,  248,  147,  249,   81,   81,   78,
   45,   17,   81,  199,   16,   99,  315,   81,  206,   81,
   81,   81,  104,  108,  385,   81,  546,   81,  290,  621,
  647,   81,  626,  487,  312,   81,   81,   52,   81,  509,
   81,   52,   52,   52,  508,  542,   52,   52,   52,   52,
   52,  495,   52,   52,   52,   52,   52,   52,   52,  488,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,  375,  525,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,  605,  383,  552,   52,   52,  232,  233,  234,  235,
  236,  237,  238,  506,  239,  240,  241,  120,  559,  242,
  581,  578,  243,  244,  573,   52,  384,  245,   52,  246,
  247,  248,    0,  249,    0,    0,    0,    0,   52,   52,
    0,    0,    0,   52,    0,    0,    0,    0,   52,    0,
   52,   52,   52,    0,    0,    0,   52,    0,   52,    0,
    0,    0,   52,  206,    0,    0,   52,   52,    0,    0,
   52,   52,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   13,    0,    0,    0,   13,   13,   13,    0,
    0,   13,   13,   13,    0,   13,    0,   13,   13,   13,
   13,   13,   13,   13,    0,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,    0,    0,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,    0,    0,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,    0,    0,    0,   13,
   13,    0,    0,  234,  235,  236,  237,  238,    0,  239,
  240,  241,    0,    0,  242,    0,    0,  243,  244,    0,
   13,    0,  245,   13,  246,  247,  248,    0,  249,    0,
    0,    0,    0,   13,   13,    0,    0,    0,   13,    0,
    0,    0,    0,   13,    0,   13,   13,   13,  174,  174,
  174,   13,    0,   13,    0,    0,    0,   13,    0,    0,
    0,   13,   13,    0,  174,  174,    0,  174,  174,  174,
  174,  174,  174,  174,  174,  174,  174,  174,  174,    0,
  179,   51,  179,  179,    0,    0,  179,    0,    0,    0,
    0,    0,    0,  174,  174,  174,    0,    0,    0,    0,
    0,  174,  174,  174,  147,  180,    0,  180,  180,  174,
  174,  180,  174,  174,  174,  174,  174,  174,  174,  174,
  174,  174,  174,   51,   51,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  174,    0,    0,  174,  174,  174,  174,    0,
    0,    0,    0,    0,    0,    0,  174,    0,    0,    0,
  174,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  174,
    0,    0,    0,    0,    0,    0,    0,  174,  174,    0,
  174,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  174,    0,    0,    0,  174,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  174,   11,   11,   11,    0,    0,
   11,   11,   11,  174,   11,    0,    0,   11,   11,   11,
   11,   11,   11,    0,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,    0,    0,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,    0,    0,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,    0,    0,    0,   11,   11,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   11,
    0,    0,   11,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   11,   11,    0,    0,    0,   11,    0,    0,
    0,    0,   11,    0,   11,   11,   11,    0,    0,    0,
   11,    0,   11,    0,    0,    0,   11,    9,   10,   11,
   11,   11,   12,   13,   14,    0,   15,    0,    0,   16,
   17,   18,   19,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,    0,    0,
   34,    0,    0,    0,    0,    0,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,    0,    0,   46,
   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,    0,
   64,   65,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   66,    0,    0,   67,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   68,   69,    0,    0,    0,   70,
    0,    0,    0,    0,   71,    0,   72,   73,   74,    0,
    0,    0,   75,    0,   76,    0,    0,    0,   77,    9,
   10,   11,   78,   79,   12,   13,   14,    0,   15,    0,
    0,   16,   17,   18,   19,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
    0,    0,   34,    0,    0,    0,    0,    0,   35,   36,
   37,   38,   39,   40,   41,   42,   43,   44,   45,    0,
    0,   46,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   66,    0,    0,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   68,   69,    0,    0,
    0,   70,    0,    0,    0,    0,   71,    0,   72,   73,
   74,    0,    0,    0,   75,    0,   76,    0,    0,    0,
   77,    9,   10,   11,   78,   79,   12,   13,  289,    0,
   15,    0,    0,   16,   17,   18,   19,   20,   21,    0,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,   33,    0,    0,   34,    0,    0,    0,    0,    0,
   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
   45,    0,    0,   46,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,    0,   64,   65,  288,  288,    0,  288,
    0,  288,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    0,
    0,    0,   77,    0,    0,    0,   78,   79,    0,  567,
  206,    0,    0,    0,    0,    0,  288,  288,  288,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,    0,  288,  288,  288,    0,    0,  288,    0,
    0,  288,  288,    0,    0,    0,  288,  288,  288,  288,
  288,    0,  288,  288,   44,   44,    0,   44,    0,   44,
    0,  288,  207,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,    0,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  237,  238,    0,  239,  240,  241,    0,
    0,  242,    0,    0,  243,  244,    0,    0,    0,  245,
    0,  246,  247,  248,    0,  249,    0,   43,    0,   43,
    0,   43,    0,    0,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
    0,   44,   44,   44,    0,    0,   44,    0,    0,   44,
   44,    0,    0,    0,   44,   44,   44,   44,   44,    0,
   44,   44,  324,  324,    0,  324,   43,  324,   43,   44,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,    0,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,    0,   43,   43,   43,    0,    0,   43,    0,
    0,   43,   43,    0,    0,    0,   43,    0,   43,   43,
   43,    0,   43,    0,    0,    0,    0,  206,    0,    0,
    0,  424,  324,  324,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,    0,  324,
  324,  324,    0,    0,  324,    0,    0,  324,  324,    0,
    0,    0,  324,  324,  324,  324,  324,    0,  324,  324,
  309,  309,    0,  309,    0,  309,    0,  324,  443,  207,
  208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
  218,  219,  220,    0,  221,  222,  223,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,    0,  239,  240,  241,    0,    0,  242,    0,
    0,  243,  244,    0,    0,    0,  245,    0,  246,  247,
  248,    0,  249,    0,    0,  206,    0,    0,    0,    0,
  309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
  309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
  309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
  309,  309,  309,  309,  309,  309,    0,  309,  309,  309,
    0,    0,  309,    0,    0,  309,  309,    0,    0,    0,
  309,  309,  309,  309,  309,    0,  309,  309,  223,  223,
    0,  223,    0,  223,    0,  309,  272,  207,  208,  209,
  210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
  220,    0,  221,  222,  223,  224,  225,  226,  227,  228,
  229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
    0,  239,  240,  241,    0,    0,  242,  206,    0,  243,
  244,    0,    0,    0,  245,    0,  246,  247,  248,    0,
  249,    0,    0,    0,    0,    0,    0,    0,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,    0,  223,  223,  223,  222,  222,
    0,  222,    0,  222,    0,    0,    0,    0,    0,  223,
    0,    0,    0,    0,    0,  223,    0,    0,    0,    0,
    0,    0,  220,  223,  221,  222,  223,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,    0,  239,  240,  241,  206,    0,  242,    0,
    0,  243,  244,    0,    0,    0,  245,    0,  246,  247,
  248,    0,  249,    0,    0,    0,    0,    0,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,    0,  222,  222,  222,  224,  224,
    0,  224,    0,  224,    0,    0,    0,    0,    0,  222,
    0,    0,    0,    0,    0,  222,    0,    0,    0,    0,
    0,    0,    0,  222,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
  238,    0,  239,  240,  241,  206,    0,  242,    0,    0,
  243,  244,    0,    0,    0,  245,    0,  246,  247,  248,
    0,  249,    0,    0,    0,    0,    0,    0,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,    0,  224,  224,  224,  220,  220,
    0,  220,    0,  220,    0,    0,    0,    0,    0,  224,
    0,    0,    0,    0,    0,  224,    0,    0,    0,    0,
    0,    0,    0,  224,  223,  224,  225,  226,  227,  228,
  229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
    0,  239,  240,  241,  206,    0,  242,    0,    0,  243,
  244,    0,    0,    0,  245,    0,  246,  247,  248,    0,
  249,    0,    0,    0,    0,    0,    0,    0,  220,  220,
  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
  220,  220,  220,  220,    0,  220,  220,  220,  221,  221,
    0,  221,    0,  221,    0,    0,    0,    0,    0,  220,
    0,    0,    0,    0,    0,  220,    0,    0,    0,    0,
    0,    0,    0,  220,  224,  225,  226,  227,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,    0,
  239,  240,  241,  206,    0,  242,    0,    0,  243,  244,
    0,    0,    0,  245,    0,  246,  247,  248,    0,  249,
    0,    0,    0,    0,    0,    0,    0,    0,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,    0,  221,  221,  221,  226,  226,
    0,  226,    0,  226,    0,    0,    0,    0,    0,  221,
    0,    0,    0,    0,    0,  221,    0,    0,    0,    0,
    0,    0,    0,  221,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,  237,  238,    0,  239,
  240,  241,  206,    0,  242,    0,    0,  243,  244,    0,
    0,    0,  245,    0,  246,  247,  248,    0,  249,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,    0,  226,  226,  226,  225,  225,
    0,  225,    0,  225,    0,    0,    0,    0,    0,  226,
    0,    0,    0,    0,    0,  226,    0,    0,    0,    0,
    0,    0,    0,  226,  226,  227,  228,  229,  230,  231,
  232,  233,  234,  235,  236,  237,  238,    0,  239,  240,
  241,    0,    0,  242,    0,    0,  243,  244,    0,    0,
    0,  245,    0,  246,  247,  248,    0,  249,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,    0,  225,  225,  225,  228,  228,
    0,  228,    0,  228,    0,    0,    0,    0,    0,  225,
    0,    0,    0,    0,    0,  225,    0,    0,    0,    0,
    0,    0,    0,  225,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,    0,  228,  228,  228,  230,  230,
    0,  230,    0,  230,    0,    0,    0,    0,    0,  228,
    0,    0,    0,    0,    0,  228,    0,    0,    0,    0,
    0,    0,    0,  228,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  230,  230,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,    0,  230,  230,  230,  277,  277,
    0,  277,    0,  277,    0,    0,    0,    0,    0,  230,
    0,    0,    0,    0,    0,  230,    0,    0,    0,    0,
    0,    0,    0,  230,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,    0,  277,  277,  277,  238,  238,
    0,  238,    0,  238,    0,    0,    0,    0,    0,  277,
    0,    0,    0,    0,    0,  277,    0,    0,    0,    0,
    0,    0,    0,  277,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  235,  235,    0,  235,    0,  235,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  238,
    0,    0,    0,    0,    0,  238,    0,    0,    0,    0,
    0,    0,    0,  238,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  236,  236,    0,  236,    0,  236,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  235,    0,    0,    0,    0,
    0,  235,    0,    0,    0,    0,    0,    0,    0,  235,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  237,  237,    0,  237,
    0,  237,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  236,    0,    0,    0,    0,    0,  236,    0,    0,
    0,    0,    0,    0,    0,  236,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  239,  239,    0,  239,    0,  239,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  237,    0,    0,
    0,    0,    0,  237,    0,    0,    0,    0,    0,    0,
    0,  237,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  233,    0,
    0,  233,    0,  233,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  239,    0,    0,    0,    0,    0,  239,
    0,    0,    0,    0,    0,    0,    0,  239,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  234,    0,    0,  234,    0,  234,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  233,
    0,    0,    0,    0,    0,  233,    0,    0,    0,    0,
    0,    0,    0,  233,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  242,    0,    0,  242,    0,  242,
    0,    0,    0,    0,    0,    0,    0,    0,    9,  130,
  131,    0,  234,    0,    0,    0,    0,    0,  234,    0,
    0,    0,    0,    0,   20,   21,  234,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   48,  188,  242,  242,  242,  242,  242,  242,
  242,  242,  242,  242,  242,  242,  242,  242,  242,  242,
  242,  242,  242,  242,  242,  242,  242,  242,  242,  242,
  242,  242,  242,  242,  242,  243,    0,    0,  243,    0,
  243,    0,  189,    0,    0,  190,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  242,  191,    0,    0,    0,
  192,  242,    0,    0,    0,    0,    0,    0,    0,  242,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  193,
  315,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  252,    0,    0,  252,
    0,  252,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  243,    0,    0,    0,
    0,    0,  243,    0,    0,    0,    0,    0,    0,    0,
  243,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  253,    0,    0,  253,    0,
  253,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  252,    0,    0,
    0,    0,    0,  252,    0,    0,    0,    0,    0,    0,
    0,  252,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  254,    0,    0,  254,    0,  254,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  253,    0,    0,    0,
    0,    0,  253,    0,    0,    0,    0,    0,    0,    0,
  253,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  255,    0,    0,  255,    0,  255,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  254,    0,    0,    0,    0,
    0,  254,    0,    0,    0,    0,    0,    0,    0,  254,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  250,    0,    0,  250,    0,  250,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  255,    0,    0,    0,  251,    0,
  255,  251,    0,  251,    0,    0,    0,    0,  255,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  250,  250,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,    0,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  250,    0,  246,    0,    0,  246,  250,
  246,    0,    0,    0,    0,    0,    0,  250,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  245,  251,
    0,  245,    0,  245,    0,  251,    0,    0,    0,    0,
    0,    0,    0,  251,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  245,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  247,    0,    0,  247,    0,  247,  246,    0,    0,    0,
    0,    0,  246,    0,    0,    0,    0,    0,    0,    0,
  246,  248,    0,    0,  248,    0,  248,    0,    0,  245,
    0,    0,    0,    0,    0,  245,    0,    0,    0,    0,
    0,    0,    0,  245,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  244,    0,    0,  244,    0,  244,    0,    0,    0,
    0,  247,    0,    0,    0,    0,    0,  247,    0,    0,
    0,    0,    0,    0,    0,  247,    0,    0,    0,    0,
    0,    0,  248,    0,    0,    0,    0,    0,  248,    0,
    0,    0,    0,    0,    0,    0,  248,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,    0,  244,    0,
    9,  130,  131,    0,    0,    0,   13,   14,    0,   15,
    0,    0,   16,   17,   18,   19,   20,   21,    0,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
    0,    0,  244,    0,    0,    0,    0,    0,  244,   35,
   36,    0,    0,    0,    0,    0,  244,    0,    0,   45,
    0,    0,    0,   47,   48,   49,    0,    0,   52,   53,
   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
    0,    0,    0,   64,   65,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   66,    0,    0,   67,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,   69,    0,
    0,    0,   70,    0,    0,    0,    0,   71,    0,   72,
   73,   74,    0,    0,    0,  161,    0,   76,    9,  130,
  131,   77,    0,    0,   13,    0,    0,   15,    0,    0,
   16,   17,   18,   19,   20,   21,    0,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   35,   36,    0,
    0,    0,    0,    0,    0,    0,    0,   45,    0,    0,
    0,   47,   48,   49,    0,    0,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,    0,    0,
    0,   64,   65,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   66,    0,    0,   67,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   68,   69,    0,    0,    0,
   70,    0,    0,    0,    0,   71,    0,   72,   73,   74,
    0,    0,    0,   75,    0,   76,    9,  130,  131,   77,
    0,    0,   13,  407,  475,   15,    0,    0,    0,    0,
    0,    0,   20,   21,    0,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   45,    0,    0,    0,  476,
   48,   49,    0,    0,   52,   53,   54,   55,   56,   57,
   58,   59,   60,   61,   62,   63,    0,    0,    0,   64,
   65,  477,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,   67,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   68,   69,    0,    0,    0,   70,    0,
    0,    0,    0,   71,    0,   72,   73,   74,    0,    0,
    0,  478,    0,   76,    9,  130,  131,   77,    0,    0,
   13,    0,  599,   15,    0,    0,    0,    0,    0,    0,
   20,   21,    0,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   45,    0,    0,    0,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,    0,   64,   65,  477,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   66,    0,
    0,   67,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,   69,    0,    0,    0,   70,    0,    0,    0,
    0,   71,    0,   72,   73,   74,    0,    0,    0,   75,
    0,   76,    9,  130,  131,   77,    0,    0,   13,  407,
  602,   15,    0,    0,    0,    0,    0,    0,   20,   21,
    0,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   45,    0,    0,    0,   47,   48,   49,    0,    0,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,    0,   64,   65,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   66,    0,    0,   67,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
   69,    0,    0,    0,   70,    0,    0,    0,    0,   71,
    0,   72,   73,   74,    0,    0,    0,  478,    0,   76,
    9,  130,  131,   77,    0,    0,   13,    0,    0,   15,
    0,    0,    0,    0,    0,    0,   20,   21,    0,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   45,
    0,    0,    0,   47,   48,   49,    0,    0,   52,   53,
   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
    0,    0,    0,   64,   65,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   66,    0,    0,   67,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,  279,    0,
    0,    0,   70,    0,    0,    0,    0,   71,    0,   72,
   73,   74,    0,    0,    0,   75,  160,   76,    9,  130,
  131,   77,    0,    0,   13,    0,    0,   15,  309,    0,
    0,    0,    0,    0,   20,   21,    0,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   45,    0,    0,
    0,   47,   48,   49,    0,    0,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,    0,    0,
    0,   64,   65,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   66,    0,    0,   67,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   68,  279,    0,    0,    0,
   70,    0,    0,    0,    0,   71,    0,   72,   73,   74,
    0,    0,    0,   75,    0,   76,    9,  130,  131,   77,
    0,    0,   13,  407,    0,   15,    0,    0,    0,    0,
    0,    0,   20,   21,    0,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   45,    0,    0,    0,   47,
   48,   49,    0,    0,   52,   53,   54,   55,   56,   57,
   58,   59,   60,   61,   62,   63,    0,    0,    0,   64,
   65,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   66,    0,    0,   67,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   68,   69,    0,    0,    0,   70,    0,
    0,    0,    0,   71,    0,   72,   73,   74,    0,    0,
    0,   75,    0,   76,    9,  130,  131,   77,    0,    0,
   13,    0,    0,   15,    0,    0,    0,    0,    0,    0,
   20,   21,    0,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   45,    0,    0,    0,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,    0,   64,   65,  477,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   66,    0,
    0,   67,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,   69,    0,    0,    0,   70,    0,    0,    0,
    0,   71,    0,   72,   73,   74,    0,    0,    0,   75,
    0,   76,    9,  130,  131,   77,    0,    0,   13,  407,
    0,   15,    0,    0,    0,    0,    0,    0,   20,   21,
    0,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   45,    0,    0,    0,   47,   48,   49,    0,    0,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,    0,   64,   65,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   66,    0,    0,   67,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
   69,    0,    0,    0,   70,    0,    0,    0,    0,   71,
    0,   72,   73,   74,    0,    0,    0,  478,    0,   76,
    9,  130,  131,   77,    0,    0,   13,    0,    0,   15,
    0,    0,    0,    0,    0,    0,   20,   21,    0,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   45,
    0,    0,    0,   47,   48,   49,    0,    0,   52,   53,
   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
    0,    0,    0,   64,   65,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   66,    0,    0,   67,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,   69,    0,
    0,    0,   70,    9,  130,  131,    0,   71,    0,   72,
   73,   74,    0,    0,    0,   75,    0,   76,    0,   20,
   21,   77,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    9,  130,  131,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  429,  430,  188,    0,
   20,   21,    0,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  206,
    0,    0,    0,    0,    0,    0,    0,  189,   48,  188,
  190,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  191,    0,    0,    0,  192,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  193,    0,    0,    0,  189,    0,
    0,  190,    0,  206,    0,    0,    0,    0,    0,    0,
    0,    0,  191,    0,    0,    0,  192,    0,    0,    0,
  391,  207,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  193,  221,  222,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  206,    0,
  242,    0,    0,  243,  244,    0,    0,    0,  245,    0,
  246,  247,  248,    0,  249,  207,  208,  209,  210,  211,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  440,
  221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,  237,  238,    0,  239,
  240,  241,    0,  276,  242,    0,    0,  243,  244,    0,
    0,    0,  245,    0,  246,  247,  248,  531,  249,    0,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,    0,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,    0,  239,  240,  241,  206,    0,  242,
    0,    0,  243,  244,    0,    0,    0,  245,    0,  246,
  247,  248,    0,  249,  276,  276,  276,  276,  276,  276,
  276,  276,  276,  276,  276,  276,  276,  276,  276,    0,
  276,  276,  276,  276,  276,  276,  276,  276,  276,  276,
  276,  276,  276,  276,  276,  276,  276,  276,    0,  276,
  276,  276,    0,    0,  276,    0,    0,  276,  276,    0,
    0,    0,  276,    0,  276,  276,  276,    0,  276,  207,
  208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
  218,  219,  220,    0,  221,  222,  223,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,    0,  239,  240,  241,    0,    0,  242,    0,
    0,  243,  244,    0,    0,    0,  245,    0,  246,  247,
  248,    0,  249,
};
short yycheck[] = {                                       7,
  416,  359,   77,    7,   44,   44,   82,   34,  256,  253,
  265,  290,   95,  265,   87,  167,    7,  187,  532,  265,
  265,  168,  515,  271,  100,  267,  109,  110,  265,  313,
  265,  268,  265,  270,  313,  267,   44,   77,  291,  305,
  291,  265,  291,  195,  265,  289,  291,  405,  267,   45,
  123,  265,  184,   44,   50,  265,  291,  271,   66,   67,
  265,   69,   70,  267,  140,  337,  268,  143,  270,   77,
   66,   67,   68,   69,   70,   71,   72,   73,   74,  265,
  267,  336,  337,  265,   44,  265,   77,   95,  314,  315,
  336,  337,  313,  314,  315,  103,  589,  352,  335,  336,
  337,  109,  110,  336,  337,  338,  352,  291,  392,  291,
   84,  268,  336,  245,  386,  352,  248,   77,  201,  338,
  270,  400,  291,   33,   89,  639,  267,  393,   38,   39,
   40,   41,  337,  394,  338,  337,   46,  392,  268,  392,
  392,  392,  270,  392,  313,  400,  392,  392,  400,  386,
  336,  298,  400,  161,  400,  392,  336,  337,  166,  124,
  125,  126,  127,  400,  204,  161,  352,  400,   78,   79,
  586,  291,  352,  138,  291,  533,  184,  185,  330,  400,
  337,  189,  190,  191,  192,  193,  400,  337,  184,  605,
  400,  265,  256,  201,  258,  400,  204,  338,  265,  290,
  165,  268,  386,  270,  265,  270,  392,  337,  265,  337,
  206,  477,  392,  204,  400,  180,  265,  337,  400,  302,
  400,  433,  313,  298,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,  204,  253,  386,  417,  418,  245,
  420,  421,  248,  249,  250,  251,  332,  265,  331,  391,
  526,  265,  336,  337,  392,  531,  386,  263,  335,  336,
  337,  279,  337,  265,  337,  267,  272,   97,  352,  336,
  596,  289,  268,  279,  290,  352,  498,  197,  198,  199,
  385,  270,  202,  387,  302,  352,  391,  387,  392,  268,
  298,  268,  329,   34,  548,  267,  400,  313,  372,  305,
  400,  265,  337,  133,  290,  291,  632,  305,  392,  386,
  328,  286,  296,  386,  291,  392,  400,  313,  290,  291,
  268,  313,  270,  400,  313,  392,  376,  313,  378,  379,
  380,  380,  489,  400,  313,  255,  338,  313,  314,  265,
  497,  313,  268,  291,  394,  502,  386,  387,  337,  313,
  314,  313,  314,  315,   95,  448,  449,  313,  376,  315,
  378,  379,  380,  291,  292,  619,  294,  295,  109,  110,
  298,  313,  313,  337,  315,  376,  394,  378,  379,  380,
  473,  635,  313,  314,  315,  391,  377,  391,  545,  380,
  381,  645,  367,  394,  385,  313,  387,  388,  389,  265,
  391,  407,  270,  392,  658,  387,  376,  425,  378,  379,
  380,  310,  311,  385,  386,  387,  313,  265,  315,  391,
  392,  385,  290,  291,  394,  386,  387,  391,  400,  337,
  448,  449,  469,  590,  440,  592,  593,  443,  318,  319,
  320,  321,  322,  392,  185,  313,  314,  392,  189,  190,
  191,  192,  193,  428,  611,  473,  541,  507,  615,  465,
  201,  400,  512,  513,  501,  471,  516,  516,  332,  337,
  627,  477,  629,  272,  273,  274,  275,  268,  394,  270,
  637,  292,  466,  294,  295,  460,  313,  462,  463,  507,
    0,  310,  311,  511,  512,  513,  514,  511,  516,  482,
  514,  484,  391,  478,  522,  338,  507,  313,  522,  518,
  519,  512,  513,  400,  265,  516,  313,  313,  386,  387,
  526,  268,  268,  337,  392,  531,  532,  265,  534,  268,
  548,  391,  400,  391,  391,  391,  391,  507,  313,  624,
  625,  268,  512,  513,  594,  394,  516,  386,  523,  391,
  267,  557,  392,  391,  560,  539,  562,  337,  542,  391,
  386,  302,  386,  337,  291,  292,  550,  294,  295,  553,
  554,  298,  392,  313,  558,  392,  594,  561,  584,  563,
  598,  313,  386,  386,  598,  392,  604,  328,  329,  265,
  604,  268,  268,  594,  270,  372,  373,  374,  265,  265,
  377,  619,  392,  380,  381,  302,  400,  591,  385,  392,
  387,  388,  389,  400,  391,  266,  368,  635,  265,  392,
  392,  268,  392,  270,  594,  267,  338,  645,  612,  268,
  399,    0,  313,  639,  270,  265,  337,  337,  622,  265,
  658,  400,  391,  265,  392,  265,  391,  265,  392,  392,
  392,  338,  337,  337,  638,  630,  392,  641,  337,  335,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  659,  352,  391,  265,  267,
  313,  267,  267,  267,  425,  313,  268,  270,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  448,  449,  268,
  386,  338,  392,  337,  392,  398,  392,  368,  369,  370,
  392,  372,  373,  374,  400,  268,  377,  268,  469,  380,
  381,  266,  473,  352,  385,  265,  387,  388,  389,  386,
  391,  386,  352,  352,  313,  392,  256,  268,  313,  352,
  260,  261,  262,  400,  305,  265,  266,  267,  268,  269,
  501,  271,  272,  273,  274,  275,  276,  277,  305,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,    0,  291,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  298,  400,  291,  333,  334,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  400,  372,  373,  374,
  386,  338,  377,  392,  354,  380,  381,  357,  386,  265,
  385,  265,  387,  388,  389,  313,  391,  367,  368,  392,
  313,  268,  372,  268,  268,  268,  386,  377,  266,  379,
  380,  381,  268,  352,  274,  385,  501,  387,  166,  597,
  633,  391,  607,  414,  184,  395,  396,  256,  398,  449,
  400,  260,  261,  262,  448,  496,  265,  266,  267,  268,
  269,  425,  271,  272,  273,  274,  275,  276,  277,  415,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  263,  473,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  566,  272,  513,  333,  334,  364,  365,  366,  367,
  368,  369,  370,  443,  372,  373,  374,   15,  517,  377,
  536,  534,  380,  381,  531,  354,  273,  385,  357,  387,
  388,  389,   -1,  391,   -1,   -1,   -1,   -1,  367,  368,
   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,   -1,
  379,  380,  381,   -1,   -1,   -1,  385,   -1,  387,   -1,
   -1,   -1,  391,  266,   -1,   -1,  395,  396,   -1,   -1,
  399,  400,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,   -1,   -1,   -1,  260,  261,  262,   -1,
   -1,  265,  266,  267,   -1,  269,   -1,  271,  272,  273,
  274,  275,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,   -1,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,   -1,   -1,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,
  334,   -1,   -1,  366,  367,  368,  369,  370,   -1,  372,
  373,  374,   -1,   -1,  377,   -1,   -1,  380,  381,   -1,
  354,   -1,  385,  357,  387,  388,  389,   -1,  391,   -1,
   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,  372,   -1,
   -1,   -1,   -1,  377,   -1,  379,  380,  381,  260,  261,
  262,  385,   -1,  387,   -1,   -1,   -1,  391,   -1,   -1,
   -1,  395,  396,   -1,  276,  277,   -1,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
  292,  268,  294,  295,   -1,   -1,  298,   -1,   -1,   -1,
   -1,   -1,   -1,  260,  261,  262,   -1,   -1,   -1,   -1,
   -1,  313,  314,  315,  291,  292,   -1,  294,  295,  276,
  277,  298,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  310,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,  357,  313,  314,  315,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  368,   -1,   -1,   -1,
  372,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  391,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,  400,   -1,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  391,  260,  261,  262,   -1,   -1,
  265,  266,  267,  400,  269,   -1,   -1,  272,  273,  274,
  275,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,   -1,   -1,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,   -1,   -1,  312,  313,  314,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,
   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  367,  368,   -1,   -1,   -1,  372,   -1,   -1,
   -1,   -1,  377,   -1,  379,  380,  381,   -1,   -1,   -1,
  385,   -1,  387,   -1,   -1,   -1,  391,  260,  261,  262,
  395,  396,  265,  266,  267,   -1,  269,   -1,   -1,  272,
  273,  274,  275,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,   -1,   -1,
  293,   -1,   -1,   -1,   -1,   -1,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,   -1,   -1,  312,
  313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,
  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,  372,
   -1,   -1,   -1,   -1,  377,   -1,  379,  380,  381,   -1,
   -1,   -1,  385,   -1,  387,   -1,   -1,   -1,  391,  260,
  261,  262,  395,  396,  265,  266,  267,   -1,  269,   -1,
   -1,  272,  273,  274,  275,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,   -1,
   -1,  312,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,   -1,
   -1,  372,   -1,   -1,   -1,   -1,  377,   -1,  379,  380,
  381,   -1,   -1,   -1,  385,   -1,  387,   -1,   -1,   -1,
  391,  260,  261,  262,  395,  396,  265,  266,  267,   -1,
  269,   -1,   -1,  272,  273,  274,  275,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,   -1,   -1,  293,   -1,   -1,   -1,   -1,   -1,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,   -1,   -1,  312,  313,  314,  315,   -1,   -1,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,   -1,   -1,   -1,  333,  334,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,
   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,   -1,
  379,  380,  381,   -1,   -1,   -1,  385,   -1,  387,   -1,
   -1,   -1,  391,   -1,   -1,   -1,  395,  396,   -1,  265,
  266,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,   -1,  372,  373,  374,   -1,   -1,  377,   -1,
   -1,  380,  381,   -1,   -1,   -1,  385,  386,  387,  388,
  389,   -1,  391,  392,  265,  266,   -1,  268,   -1,  270,
   -1,  400,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,   -1,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,   -1,  372,  373,  374,   -1,
   -1,  377,   -1,   -1,  380,  381,   -1,   -1,   -1,  385,
   -1,  387,  388,  389,   -1,  391,   -1,  266,   -1,  268,
   -1,  270,   -1,   -1,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
   -1,  372,  373,  374,   -1,   -1,  377,   -1,   -1,  380,
  381,   -1,   -1,   -1,  385,  386,  387,  388,  389,   -1,
  391,  392,  265,  266,   -1,  268,  335,  270,  337,  400,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,   -1,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,   -1,  372,  373,  374,   -1,   -1,  377,   -1,
   -1,  380,  381,   -1,   -1,   -1,  385,   -1,  387,  388,
  389,   -1,  391,   -1,   -1,   -1,   -1,  266,   -1,   -1,
   -1,  270,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,   -1,  372,
  373,  374,   -1,   -1,  377,   -1,   -1,  380,  381,   -1,
   -1,   -1,  385,  386,  387,  388,  389,   -1,  391,  392,
  265,  266,   -1,  268,   -1,  270,   -1,  400,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,   -1,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,   -1,  372,  373,  374,   -1,   -1,  377,   -1,
   -1,  380,  381,   -1,   -1,   -1,  385,   -1,  387,  388,
  389,   -1,  391,   -1,   -1,  266,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,  372,  373,  374,
   -1,   -1,  377,   -1,   -1,  380,  381,   -1,   -1,   -1,
  385,  386,  387,  388,  389,   -1,  391,  392,  265,  266,
   -1,  268,   -1,  270,   -1,  400,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,   -1,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
   -1,  372,  373,  374,   -1,   -1,  377,  266,   -1,  380,
  381,   -1,   -1,   -1,  385,   -1,  387,  388,  389,   -1,
  391,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,  351,  400,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,   -1,  372,  373,  374,  266,   -1,  377,   -1,
   -1,  380,  381,   -1,   -1,   -1,  385,   -1,  387,  388,
  389,   -1,  391,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,   -1,  372,  373,  374,  266,   -1,  377,   -1,   -1,
  380,  381,   -1,   -1,   -1,  385,   -1,  387,  388,  389,
   -1,  391,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
   -1,  372,  373,  374,  266,   -1,  377,   -1,   -1,  380,
  381,   -1,   -1,   -1,  385,   -1,  387,  388,  389,   -1,
  391,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,   -1,
  372,  373,  374,  266,   -1,  377,   -1,   -1,  380,  381,
   -1,   -1,   -1,  385,   -1,  387,  388,  389,   -1,  391,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,   -1,  372,
  373,  374,  266,   -1,  377,   -1,   -1,  380,  381,   -1,
   -1,   -1,  385,   -1,  387,  388,  389,   -1,  391,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,   -1,  372,  373,
  374,   -1,   -1,  377,   -1,   -1,  380,  381,   -1,   -1,
   -1,  385,   -1,  387,  388,  389,   -1,  391,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  265,  266,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  265,   -1,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,
  262,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,
   -1,   -1,   -1,   -1,  276,  277,  400,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  314,  315,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  265,   -1,   -1,  268,   -1,
  270,   -1,  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  386,  368,   -1,   -1,   -1,
  372,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  391,
  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  265,   -1,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  386,   -1,   -1,   -1,
   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  400,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  265,   -1,   -1,  268,   -1,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  386,   -1,   -1,   -1,
   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  400,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  265,   -1,   -1,  268,   -1,  270,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  400,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  265,   -1,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  386,   -1,   -1,   -1,  265,   -1,
  392,  268,   -1,  270,   -1,   -1,   -1,   -1,  400,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,   -1,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  386,   -1,  265,   -1,   -1,  268,  392,
  270,   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  265,  386,
   -1,  268,   -1,  270,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  265,   -1,   -1,  268,   -1,  270,  386,   -1,   -1,   -1,
   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  400,  265,   -1,   -1,  268,   -1,  270,   -1,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,   -1,
   -1,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,   -1,  352,   -1,
  260,  261,  262,   -1,   -1,   -1,  266,  267,   -1,  269,
   -1,   -1,  272,  273,  274,  275,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,  299,
  300,   -1,   -1,   -1,   -1,   -1,  400,   -1,   -1,  309,
   -1,   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,
   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,   -1,  379,
  380,  381,   -1,   -1,   -1,  385,   -1,  387,  260,  261,
  262,  391,   -1,   -1,  266,   -1,   -1,  269,   -1,   -1,
  272,  273,  274,  275,  276,  277,   -1,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  299,  300,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,
   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,   -1,   -1,
   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,
  372,   -1,   -1,   -1,   -1,  377,   -1,  379,  380,  381,
   -1,   -1,   -1,  385,   -1,  387,  260,  261,  262,  391,
   -1,   -1,  266,  267,  268,  269,   -1,   -1,   -1,   -1,
   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,
  314,  315,   -1,   -1,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,
  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,  372,   -1,
   -1,   -1,   -1,  377,   -1,  379,  380,  381,   -1,   -1,
   -1,  385,   -1,  387,  260,  261,  262,  391,   -1,   -1,
  266,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,
   -1,   -1,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,  335,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,
   -1,  377,   -1,  379,  380,  381,   -1,   -1,   -1,  385,
   -1,  387,  260,  261,  262,  391,   -1,   -1,  266,  267,
  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,   -1,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,
   -1,  379,  380,  381,   -1,   -1,   -1,  385,   -1,  387,
  260,  261,  262,  391,   -1,   -1,  266,   -1,   -1,  269,
   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,
   -1,   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,
   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,   -1,  379,
  380,  381,   -1,   -1,   -1,  385,  386,  387,  260,  261,
  262,  391,   -1,   -1,  266,   -1,   -1,  269,  270,   -1,
   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,
   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,   -1,   -1,
   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,
  372,   -1,   -1,   -1,   -1,  377,   -1,  379,  380,  381,
   -1,   -1,   -1,  385,   -1,  387,  260,  261,  262,  391,
   -1,   -1,  266,  267,   -1,  269,   -1,   -1,   -1,   -1,
   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,
  314,  315,   -1,   -1,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,
  334,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  354,   -1,   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,  372,   -1,
   -1,   -1,   -1,  377,   -1,  379,  380,  381,   -1,   -1,
   -1,  385,   -1,  387,  260,  261,  262,  391,   -1,   -1,
  266,   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,
   -1,   -1,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,  335,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,
   -1,  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  367,  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,
   -1,  377,   -1,  379,  380,  381,   -1,   -1,   -1,  385,
   -1,  387,  260,  261,  262,  391,   -1,   -1,  266,  267,
   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,   -1,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,
  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,  377,
   -1,  379,  380,  381,   -1,   -1,   -1,  385,   -1,  387,
  260,  261,  262,  391,   -1,   -1,  266,   -1,   -1,  269,
   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,
   -1,   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
   -1,   -1,   -1,  333,  334,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  354,   -1,   -1,  357,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  367,  368,   -1,
   -1,   -1,  372,  260,  261,  262,   -1,  377,   -1,  379,
  380,  381,   -1,   -1,   -1,  385,   -1,  387,   -1,  276,
  277,  391,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  260,  261,  262,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  313,  314,  315,   -1,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  266,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  354,  314,  315,
  357,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  391,   -1,   -1,   -1,  354,   -1,
   -1,  357,   -1,  266,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  368,   -1,   -1,   -1,  372,   -1,   -1,   -1,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  391,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,  372,  373,  374,  266,   -1,
  377,   -1,   -1,  380,  381,   -1,   -1,   -1,  385,   -1,
  387,  388,  389,   -1,  391,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,   -1,  372,
  373,  374,   -1,  266,  377,   -1,   -1,  380,  381,   -1,
   -1,   -1,  385,   -1,  387,  388,  389,  335,  391,   -1,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,   -1,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,   -1,  372,  373,  374,  266,   -1,  377,
   -1,   -1,  380,  381,   -1,   -1,   -1,  385,   -1,  387,
  388,  389,   -1,  391,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,   -1,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,   -1,  372,
  373,  374,   -1,   -1,  377,   -1,   -1,  380,  381,   -1,
   -1,   -1,  385,   -1,  387,  388,  389,   -1,  391,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,   -1,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,   -1,  372,  373,  374,   -1,   -1,  377,   -1,
   -1,  380,  381,   -1,   -1,   -1,  385,   -1,  387,  388,
  389,   -1,  391,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 400
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"VAR","EXPR","ARRAY","STRUCT",
"UNION","ENUM","COMP","HASH","SEMI","MOD","OC","CC","DOLLAR","DOTDOTDOT",
"ENDFILE","GLOBAL","AUTO","STATIC","CONST","POLY","INTEGER","NATURAL",
"RATIONAL","REAL","STRING","FOREIGN","FILET","MUTEX","SEMAPHORE","CONTINUATION",
"THREAD","VOID","BOOL","FUNCTION","FUNC","EXCEPTION","RAISE","TYPEDEF","IMPORT",
"NEW","ANONINIT","NAMESPACE","PUBLIC","PROTECTED","EXTEND","WHILE","DO","FOR",
"SWITCH","BREAK","CONTINUE","RETURNTOK","FORK","CASE","DEFAULT","TWIXT","NAME",
"TYPENAME","NAMESPACENAME","COMMAND","NAMECOMMAND","TEN_NUM","OCTAL0_NUM",
"OCTAL_NUM","BINARY_NUM","HEX_NUM","TEN_FLOAT","OCTAL0_FLOAT","OCTAL_FLOAT",
"BINARY_FLOAT","HEX_FLOAT","CHAR_CONST","STRING_CONST","POLY_CONST",
"THREAD_CONST","COMMENT_CONST","VOIDVAL","BOOLVAL","DARROW","POUND","COMMA",
"ASSIGN","ASSIGNPLUS","ASSIGNMINUS","ASSIGNTIMES","ASSIGNDIVIDE","ASSIGNDIV",
"ASSIGNMOD","ASSIGNPOW","ASSIGNSHIFTL","ASSIGNSHIFTR","ASSIGNLXOR","ASSIGNLAND",
"ASSIGNLOR","QUEST","COLON","OR","AND","LOR","LXOR","LAND","EQ","NE","LT","GT",
"LE","GE","SHIFTL","SHIFTR","PLUS","MINUS","TIMES","DIVIDE","DIV","POW",
"STARSTAR","POW2","POW3","UNIONCAST","UMINUS","BANG","FACT","LNOT","INC","DEC",
"STAR","AMPER","THREADID","OS","CS","DOT","ARROW","STAROS","CALL","OP","CP",
"POINTER","COLONCOLON","IF","TRY","NONL","ELSE","CATCH","NL",
};
char *yyrule[] = {
"$accept : lines",
"lines : lines pcommand",
"lines :",
"pcommand : command",
"pcommand : error reset eend",
"eend : NL",
"eend : SEMI",
"eend : ENDFILE",
"ignorenl :",
"attendnl :",
"reset :",
"not_command :",
"opt_nl : NL",
"opt_nl :",
"opt_semi : SEMI",
"opt_semi :",
"opt_comma : COMMA",
"opt_comma :",
"command : not_command expr reset NL",
"command : not_command expr POUND expr reset NL",
"command : not_command statement reset opt_nl",
"command : not_command COMMAND opt_exprs reset opt_semi NL",
"command : not_command NAMECOMMAND opt_rawnames reset opt_semi NL",
"command : NL",
"command : ENDFILE",
"opt_rawnames : rawnames",
"opt_rawnames :",
"rawnames : rawname COMMA rawnames",
"rawnames : rawname",
"rawname : rawnamespace rawatom",
"rawatom : NAME",
"rawatom : NAMESPACENAME",
"rawatom : TYPENAME",
"rawnamespace : rawnamespace rawatom COLONCOLON",
"rawnamespace :",
"fulltype : namespace TYPENAME",
"fulltype : TYPENAME",
"fullname : namespace namespacename",
"fullname : namespacename",
"fullnames : fullname",
"fullnames : fullname COMMA fullnames",
"namespace : namespace NAMESPACENAME COLONCOLON",
"namespace : NAMESPACENAME COLONCOLON",
"namespacename : NAME",
"namespacename : NAMESPACENAME",
"namespace_start :",
"namespace_end :",
"block : block_start statements block_end",
"block_start : OC namespace_start",
"block_end : namespace_end CC",
"statements : statement statements",
"statements :",
"if_statement : IF ignorenl namespace_start OP expr CP statement",
"if_statement : IF ignorenl namespace_start OP expr CP statement ELSE statement",
"statement : simple_statement",
"statement : block",
"simple_statement : if_statement namespace_end attendnl",
"simple_statement : WHILE ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"simple_statement : DO ignorenl namespace_start statement WHILE OP expr CP namespace_end attendnl",
"simple_statement : FOR ignorenl namespace_start OP for_exprs CP statement namespace_end attendnl",
"simple_statement : SWITCH ignorenl namespace_start OP expr CP case_block namespace_end attendnl",
"simple_statement : union_or_enum SWITCH ignorenl namespace_start OP expr CP union_case_block namespace_end attendnl",
"simple_statement : BREAK SEMI",
"simple_statement : CONTINUE SEMI",
"simple_statement : RETURNTOK opt_expr SEMI",
"simple_statement : expr SEMI",
"simple_statement : SEMI",
"simple_statement : func_decl doc_string opt_func_body namespace_end",
"simple_statement : opt_publish EXCEPTION ignorenl NAME namespace_start opt_argdecls namespace_end doc_string SEMI attendnl",
"simple_statement : RAISE fullname OP opt_exprs CP SEMI",
"simple_statement : opt_publish TYPEDEF ignorenl typenames SEMI attendnl",
"simple_statement : opt_publish TYPEDEF ignorenl type typenames SEMI attendnl",
"$$1 :",
"simple_statement : publish_extend NAMESPACE ignorenl namespacename $$1 OC statements CC attendnl",
"simple_statement : opt_publish IMPORT ignorenl fullnames SEMI attendnl",
"simple_statement : try_statement attendnl",
"simple_statement : TWIXT ignorenl namespace_start OP opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"for_exprs : opt_expr SEMI for_exprs",
"for_exprs : opt_expr",
"try_body_statement : simple_statement",
"try_body_statement : OC statements CC",
"try_statement : TRY ignorenl try_body_statement catches",
"catches : catches catch",
"catches :",
"catch : CATCH fullname namespace_start args doc_string block namespace_end",
"opt_func_body : func_body",
"opt_func_body : SEMI",
"$$2 :",
"func_body : $$2 block_or_expr",
"block_or_expr : block",
"block_or_expr : attendnl ASSIGN simpleexpr SEMI",
"union_or_enum : UNION",
"union_or_enum : ENUM",
"see_comment :",
"doc_string : see_comment opt_comment",
"opt_comment : COMMENT_CONST",
"opt_comment :",
"case_block : block_start cases block_end",
"cases : case cases",
"cases :",
"case : CASE expr COLON statements",
"case : DEFAULT COLON statements",
"union_case_block : block_start union_cases block_end",
"union_cases : union_case union_cases",
"union_cases :",
"union_case : CASE namespace_start NAME opt_name COLON statements namespace_end",
"union_case : DEFAULT COLON statements",
"opt_name : NAME",
"opt_name :",
"atoms : NAME COMMA atoms",
"atoms : NAME",
"typenames : typename COMMA typenames",
"typenames : typename",
"typename : TYPENAME",
"typename : NAME",
"initnames : name opt_init next_decl initnames",
"initnames : name opt_init",
"name : NAME",
"next_decl : COMMA",
"func_decl : func_name namespace_start opt_argdefines CP",
"func_name : decl NAME OP",
"func_name : decl FUNCTION NAME OP",
"func_name : FUNCTION ignorenl NAME OP",
"opt_init : ASSIGN simpleexpr",
"opt_init : ASSIGN init",
"opt_init :",
"decl : publish opt_class opt_type opt_nl",
"decl : class opt_type opt_nl",
"decl : type opt_nl",
"subscripts : opt_argdecls subscripts",
"subscripts : OS opt_stars CS subscripts",
"subscripts : OS dotdotdots CS subscripts",
"subscripts : OS dims CS subscripts",
"subscripts : OS type CS subscripts",
"subscripts :",
"type : subtype subscripts",
"type : TIMES type",
"type : STARSTAR type",
"type : AND type",
"type : LAND type",
"subtype : basetype",
"subtype : STRUCT OC struct_members CC",
"subtype : UNION OC union_members CC",
"subtype : ENUM OC atoms CC",
"subtype : OP type CP",
"subtype : fulltype",
"opt_type : type",
"opt_type :",
"basetype : POLY",
"basetype : INTEGER",
"basetype : RATIONAL",
"basetype : REAL",
"basetype : STRING",
"basetype : FILET",
"basetype : MUTEX",
"basetype : SEMAPHORE",
"basetype : CONTINUATION",
"basetype : THREAD",
"basetype : VOID",
"basetype : BOOL",
"basetype : FOREIGN",
"opt_stars : stars",
"opt_stars :",
"stars : stars COMMA TIMES",
"stars : TIMES",
"dotdotdots : dotdotdots COMMA DOTDOTDOT",
"dotdotdots : DOTDOTDOT",
"dims : simpleexpr COMMA dims",
"dims : simpleexpr",
"struct_members : opt_type atoms SEMI struct_members",
"struct_members :",
"union_members : opt_type atoms SEMI union_members",
"union_members :",
"opt_class : class",
"opt_class :",
"class : GLOBAL",
"class : AUTO",
"class : STATIC",
"class : CONST",
"opt_publish : publish",
"opt_publish :",
"publish : PUBLIC",
"publish : PROTECTED",
"publish_extend : opt_publish",
"publish_extend : EXTEND",
"opt_argdecls : OP argdecls CP",
"opt_argdecls : OP CP",
"argdecls : argdecl COMMA argdecls",
"argdecls : argdecl opt_dotdotdot",
"argdecl : type NAME",
"argdecl : type",
"args : OP opt_argdefines CP",
"opt_argdefines : ignorenl argdefines",
"opt_argdefines : ignorenl",
"argdefines : argdefine COMMA argdefines",
"argdefines : argdefine opt_dotdotdot",
"argdefine : opt_type NAME",
"argdefine : type",
"opt_dotdotdot : DOTDOTDOT",
"opt_dotdotdot :",
"opt_expr : expr",
"opt_expr :",
"expr : comma_expr",
"expr : decl initnames",
"comma_expr : simpleexpr",
"comma_expr : comma_expr COMMA simpleexpr",
"opt_exprs : exprs",
"opt_exprs :",
"exprs : simpleexpr COMMA exprs",
"exprs : simpleexpr",
"opt_actuals : actuals",
"opt_actuals :",
"actuals : simpleexpr COMMA actuals",
"actuals : simpleexpr opt_dotdotdot",
"func_right : attendnl ASSIGN simpleexpr",
"$$3 :",
"func_right : $$3 block",
"simpleexpr : simpleexpr assignop simpleexpr",
"simpleexpr : opt_type FUNC namespace_start args doc_string func_right namespace_end",
"simpleexpr : MOD integer",
"simpleexpr : TIMES simpleexpr",
"simpleexpr : STARSTAR simpleexpr",
"simpleexpr : LAND simpleexpr",
"simpleexpr : AND simpleexpr",
"simpleexpr : MINUS simpleexpr",
"simpleexpr : LNOT simpleexpr",
"simpleexpr : BANG simpleexpr",
"simpleexpr : simpleexpr BANG",
"simpleexpr : INC simpleexpr",
"simpleexpr : simpleexpr INC",
"simpleexpr : DEC simpleexpr",
"simpleexpr : simpleexpr DEC",
"simpleexpr : FORK simpleexpr",
"simpleexpr : simpleexpr PLUS simpleexpr",
"simpleexpr : simpleexpr MINUS simpleexpr",
"simpleexpr : simpleexpr TIMES simpleexpr",
"simpleexpr : simpleexpr DIVIDE simpleexpr",
"simpleexpr : simpleexpr DIV simpleexpr",
"simpleexpr : simpleexpr MOD simpleexpr",
"simpleexpr : simpleexpr STARSTAR simpleexpr",
"simpleexpr : simpleexpr POW2",
"simpleexpr : simpleexpr POW3",
"simpleexpr : simpleexpr SHIFTL simpleexpr",
"simpleexpr : simpleexpr SHIFTR simpleexpr",
"simpleexpr : simpleexpr QUEST simpleexpr COLON simpleexpr",
"simpleexpr : simpleexpr LXOR simpleexpr",
"simpleexpr : simpleexpr LAND simpleexpr",
"simpleexpr : simpleexpr LOR simpleexpr",
"simpleexpr : simpleexpr AND simpleexpr",
"simpleexpr : simpleexpr OR simpleexpr",
"simpleexpr : simpleexpr EQ simpleexpr",
"simpleexpr : simpleexpr NE simpleexpr",
"simpleexpr : simpleexpr LT simpleexpr",
"simpleexpr : simpleexpr GT simpleexpr",
"simpleexpr : simpleexpr LE simpleexpr",
"simpleexpr : simpleexpr GE simpleexpr",
"simpleexpr : fullname",
"simpleexpr : TEN_NUM",
"simpleexpr : OCTAL_NUM",
"simpleexpr : OCTAL0_NUM",
"simpleexpr : BINARY_NUM",
"simpleexpr : HEX_NUM",
"simpleexpr : TEN_FLOAT",
"simpleexpr : OCTAL_FLOAT",
"simpleexpr : OCTAL0_FLOAT",
"simpleexpr : BINARY_FLOAT",
"simpleexpr : HEX_FLOAT",
"simpleexpr : CHAR_CONST",
"simpleexpr : STRING_CONST",
"simpleexpr : VOIDVAL",
"simpleexpr : BOOLVAL",
"simpleexpr : OS CS",
"simpleexpr : OP type CP namespace_start init namespace_end",
"simpleexpr : OP OS stars CS CP namespace_start arrayinit namespace_end",
"simpleexpr : OP OS dims CS CP namespace_start opt_arrayinit namespace_end",
"simpleexpr : OP OS type CS CP namespace_start opt_hashinit namespace_end",
"simpleexpr : type DOT NAME",
"simpleexpr : OP type DOT NAME CP simpleexpr",
"simpleexpr : DOLLAR opt_integer",
"simpleexpr : DOT",
"simpleexpr : OP expr CP",
"simpleexpr : OP block CP",
"simpleexpr : simpleexpr STAROS dims CS",
"simpleexpr : simpleexpr OS dims CS",
"simpleexpr : simpleexpr OP opt_actuals CP",
"simpleexpr : simpleexpr DOT NAME",
"simpleexpr : simpleexpr ARROW NAME",
"opt_integer : integer",
"opt_integer :",
"assignop : ASSIGNPLUS",
"assignop : ASSIGNMINUS",
"assignop : ASSIGNTIMES",
"assignop : ASSIGNDIVIDE",
"assignop : ASSIGNDIV",
"assignop : ASSIGNMOD",
"assignop : ASSIGNPOW",
"assignop : ASSIGNSHIFTL",
"assignop : ASSIGNSHIFTR",
"assignop : ASSIGNLXOR",
"assignop : ASSIGNLAND",
"assignop : ASSIGNLOR",
"assignop : ASSIGN",
"integer : TEN_NUM",
"integer : OCTAL_NUM",
"integer : OCTAL0_NUM",
"integer : BINARY_NUM",
"integer : HEX_NUM",
"opt_arrayinit : arrayinit",
"opt_arrayinit : OC CC",
"opt_arrayinit :",
"arrayinit : OC arrayelts opt_comma opt_dotdotdot CC",
"arrayinit : OC OS namespace_start compnames comparray CS comprehension namespace_end CC",
"comprehension : ASSIGN arrayelt",
"comprehension : block",
"compnames : compname COMMA compnames",
"compnames : compname",
"compname : NAME",
"comparray :",
"arrayelts : arrayelts COMMA arrayelt",
"arrayelts : arrayelt",
"arrayelt : simpleexpr",
"arrayelt : init",
"opt_hashinit : hashinit",
"opt_hashinit : OC CC",
"opt_hashinit :",
"hashinit : OC hashelts opt_comma CC",
"hashelts : hashelts COMMA hashelt",
"hashelts : hashelt",
"hashelt : simpleexpr DARROW hashvalue",
"hashelt : DARROW hashvalue",
"hashvalue : simpleexpr",
"hashvalue : init",
"structinit : OC structelts opt_comma CC",
"structelts : structelts COMMA structelt",
"structelts : structelt",
"structelt : NAME ASSIGN simpleexpr",
"structelt : NAME ASSIGN init",
"init : arrayinit",
"init : structinit",
"init : hashinit",
"init : OC CC",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static int      yystacksize;
#line 1603 "gram.y"

static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp, CodePtr *cp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
    if (CurrentFrame)
	*cp = CurrentFrame->function->func.code;
    else
	*cp = 0;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    ArrayValueSet (&array->array, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	ArrayValueSet (&array->array, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk for() loop arguments and normalize the list
 */
static Expr *
ParseCanonFor (Expr *expr)
{
    if (!expr || !expr->tree.right) {
        ParseError ("Too few exprs in for()\n");
        return 0;
    }
    if (!expr->tree.right->tree.right) {
        /* 2-argument for() */
        expr = NewExprTree(FOR, 0, expr);
    }
    if (expr->tree.right->tree.right->tree.right) {
        ParseError ("Too many exprs in for()\n");
        return 0;
    }
    return expr;
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;
    
    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return False;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type, Void);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ignorenl = 0;
    ParseError ("%s before %S", msg, yytext);
}
#line 2874 "gram.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

#ifdef lint
    goto yyerrlab;
#endif

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 196 "gram.y"
{ yyerrok; }
break;
case 6:
#line 198 "gram.y"
{ yyerrok; }
break;
case 7:
#line 200 "gram.y"
{ yyerrok; }
break;
case 8:
#line 208 "gram.y"
{ ignorenl++; }
break;
case 9:
#line 211 "gram.y"
{ if (ignorenl > 0) ignorenl--; }
break;
case 10:
#line 214 "gram.y"
{ 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
		    }
break;
case 11:
#line 231 "gram.y"
{ notCommand = 1; }
break;
case 18:
#line 246 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, yyvsp[-2].expr, 0));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 19:
#line 262 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, yyvsp[-4].expr, 0), yyvsp[-2].expr);
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 20:
#line 278 "gram.y"
{ 
			ENTER ();
			NamespacePtr    s;
			FramePtr	f;
			CodePtr		c;
			Value		t;
			
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileStat (yyvsp[-2].expr, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 21:
#line 291 "gram.y"
{
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 22:
#line 315 "gram.y"
{
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 26:
#line 344 "gram.y"
{ yyval.expr = 0; }
break;
case 27:
#line 347 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 28:
#line 349 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 29:
#line 352 "gram.y"
{ yyval.expr = BuildRawname (yyvsp[-1].expr, yyvsp[0].atom); }
break;
case 33:
#line 359 "gram.y"
{ yyval.expr = NewExprTree (COLONCOLON, yyvsp[-2].expr, NewExprAtom (yyvsp[-1].atom, 0, False)); }
break;
case 34:
#line 361 "gram.y"
{ yyval.expr = 0; }
break;
case 35:
#line 364 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 36:
#line 369 "gram.y"
{ 
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 37:
#line 375 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 38:
#line 380 "gram.y"
{
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 39:
#line 386 "gram.y"
{
			yyval.expr = yyvsp[0].expr;
		    }
break;
case 40:
#line 390 "gram.y"
{
			yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr);
		    }
break;
case 41:
#line 395 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (yyvsp[-2].expr, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 42:
#line 418 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 45:
#line 448 "gram.y"
{ CurrentNamespace = NewNamespace (CurrentNamespace); }
break;
case 46:
#line 451 "gram.y"
{ CurrentNamespace = CurrentNamespace->previous; }
break;
case 47:
#line 454 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 50:
#line 461 "gram.y"
{ yyval.expr = NewExprTree(OC, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 51:
#line 463 "gram.y"
{ yyval.expr = NewExprTree(OC, 0, 0); }
break;
case 52:
#line 466 "gram.y"
{ yyval.expr = NewExprTree(IF, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 53:
#line 468 "gram.y"
{ yyval.expr = NewExprTree(ELSE, yyvsp[-4].expr, NewExprTree(ELSE, yyvsp[-2].expr, yyvsp[0].expr)); }
break;
case 56:
#line 475 "gram.y"
{ yyval.expr = yyvsp[-2].expr; }
break;
case 57:
#line 477 "gram.y"
{ yyval.expr = NewExprTree(WHILE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 58:
#line 479 "gram.y"
{ yyval.expr = NewExprTree(DO, yyvsp[-6].expr, yyvsp[-3].expr); }
break;
case 59:
#line 481 "gram.y"
{ Expr *expr = ParseCanonFor(yyvsp[-4].expr);
		      if (!expr)
                          YYERROR;
		      yyval.expr = NewExprTree(FOR, expr, yyvsp[-2].expr); }
break;
case 60:
#line 486 "gram.y"
{ yyval.expr = NewExprTree (SWITCH, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 61:
#line 488 "gram.y"
{ yyval.expr = NewExprTree (UNION, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 62:
#line 490 "gram.y"
{ yyval.expr = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
break;
case 63:
#line 492 "gram.y"
{ yyval.expr = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
break;
case 64:
#line 494 "gram.y"
{ yyval.expr = NewExprTree (RETURNTOK, (Expr *) 0, yyvsp[-1].expr); }
break;
case 65:
#line 496 "gram.y"
{ yyval.expr = NewExprTree(EXPR, yyvsp[-1].expr, (Expr *) 0); }
break;
case 66:
#line 498 "gram.y"
{ yyval.expr = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
break;
case 67:
#line 500 "gram.y"
{ 
			DeclList    *decl = yyvsp[-3].funcDecl.decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = yyvsp[-3].funcDecl.type.class;
			Publish	    publish = yyvsp[-3].funcDecl.type.publish;
			TypePtr	    type = yyvsp[-3].funcDecl.type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if (yyvsp[-1].expr)
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       yyvsp[-1].expr,
								       yyvsp[-2].value),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			yyval.expr = NewExprDecl (FUNC, decl, class, type, publish);
		    }
break;
case 68:
#line 527 "gram.y"
{ 
			DeclListPtr decl;

			decl = NewDeclList (yyvsp[-6].atom, 0, 0);
			decl->symbol = ParseNewSymbol (yyvsp[-9].publish, 
						       class_exception, 
						       typePoly, yyvsp[-6].atom);
			decl->symbol->exception.doc = yyvsp[-2].value;
			yyval.expr = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, yyvsp[-4].argType),
					  yyvsp[-9].publish);
		    }
break;
case 69:
#line 542 "gram.y"
{ yyval.expr = NewExprTree (RAISE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 70:
#line 544 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-5].publish, class_typedef,
							   0, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, 0, yyvsp[-5].publish), 0);
		    }
break;
case 71:
#line 553 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-6].publish, class_typedef,
							   yyvsp[-3].type, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, yyvsp[-3].type, yyvsp[-6].publish), 0);
		    }
break;
case 72:
#line 562 "gram.y"
{
			SymbolPtr   symbol;
			Publish	    publish = yyvsp[-3].publish;
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			yyvsp[-2].namespace = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, yyvsp[0].atom, True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", yyvsp[0].atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", yyvsp[0].atom);
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].publish, class_namespace,
						     0, yyvsp[0].atom);
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != yyvsp[-2].namespace)
			    CurrentNamespace->publish = publish_public;
		    }
break;
case 73:
#line 603 "gram.y"
{
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != yyvsp[-7].namespace)
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = yyvsp[-7].namespace;
			yyval.expr = NewExprTree (NAMESPACE, NewExprAtom (yyvsp[-5].atom, 0, False), yyvsp[-2].expr);
		    }
break;
case 74:
#line 617 "gram.y"
{
			SymbolPtr	symbol;
			ExprPtr		p, e, n;

			p = yyvsp[-2].expr;
			for (p = yyvsp[-2].expr; p; p = n)
			{
			    if (p->base.tag == COMMA)
			    {
				e = p->tree.left;
				n = p->tree.right;
			    }
			    else
			    {
				e = p;
				n = 0;
			    }
			    if (e->base.tag == COLONCOLON)
				e = e->tree.right;
			    symbol = e->atom.symbol;
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", e->atom.atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", e->atom.atom);
				YYERROR;
			    }
			    NamespaceImport (CurrentNamespace, 
					     symbol->namespace.namespace, yyvsp[-5].publish);
			}
			yyval.expr = NewExprTree (IMPORT, yyvsp[-2].expr, NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   yyvsp[-5].publish));
		    }
break;
case 75:
#line 657 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 76:
#line 659 "gram.y"
{ yyval.expr = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, yyvsp[-6].expr, yyvsp[-4].expr),
					NewExprTree (TWIXT, yyvsp[-2].expr, 0));
		    }
break;
case 77:
#line 665 "gram.y"
{ yyval.expr = NewExprTree(SEMI, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 78:
#line 667 "gram.y"
{ yyval.expr = NewExprTree(SEMI, yyvsp[0].expr, 0); }
break;
case 80:
#line 672 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 81:
#line 675 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[0].expr, yyvsp[-1].expr); }
break;
case 82:
#line 679 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 83:
#line 681 "gram.y"
{ yyval.expr = 0; }
break;
case 84:
#line 684 "gram.y"
{ yyval.expr = NewExprCode (NewFuncCode (typePrim[rep_void],
						     yyvsp[-3].argType, yyvsp[-1].expr, yyvsp[-2].value),
					yyvsp[-5].expr); 
		    }
break;
case 86:
#line 691 "gram.y"
{ yyval.expr = 0; }
break;
case 87:
#line 693 "gram.y"
{ ++funcDepth; }
break;
case 88:
#line 693 "gram.y"
{ --funcDepth; yyval.expr = yyvsp[0].expr; }
break;
case 89:
#line 696 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 90:
#line 698 "gram.y"
{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yyvsp[-1].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 93:
#line 708 "gram.y"
{ seeComment = 1; }
break;
case 94:
#line 711 "gram.y"
{ seeComment = 0; yyval.value = yyvsp[0].value; }
break;
case 96:
#line 715 "gram.y"
{ yyval.value = Void; }
break;
case 97:
#line 718 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 98:
#line 721 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 99:
#line 723 "gram.y"
{ yyval.expr = 0; }
break;
case 100:
#line 726 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 101:
#line 728 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 102:
#line 731 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 103:
#line 734 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 104:
#line 736 "gram.y"
{ yyval.expr = 0; }
break;
case 105:
#line 739 "gram.y"
{ 
			SymbolPtr   sym = yyvsp[-3].symbol;
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			yyval.expr = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom (yyvsp[-4].atom, 0, False),
						       name),
					  yyvsp[-1].expr);
		    }
break;
case 106:
#line 754 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 107:
#line 757 "gram.y"
{
			yyval.symbol = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     yyvsp[0].atom);
		    }
break;
case 108:
#line 764 "gram.y"
{ yyval.symbol = 0; }
break;
case 109:
#line 770 "gram.y"
{ yyval.atomList = NewAtomList (yyvsp[0].atomList, yyvsp[-2].atom); }
break;
case 110:
#line 772 "gram.y"
{ yyval.atomList = NewAtomList (0, yyvsp[0].atom); }
break;
case 111:
#line 775 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[-2].atom, 0, yyvsp[0].declList); }
break;
case 112:
#line 777 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[0].atom, 0, 0); }
break;
case 115:
#line 791 "gram.y"
{ 
			if (yyvsp[-3].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-3].symbol->symbol.name, yyvsp[-2].expr, yyvsp[0].declList); 
			    yyval.declList->symbol = yyvsp[-3].symbol;
			}
			else
			    yyval.declList = yyvsp[0].declList;
		    }
break;
case 116:
#line 801 "gram.y"
{ 
			if (yyvsp[-1].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-1].symbol->symbol.name, yyvsp[0].expr, 0);
			    yyval.declList->symbol = yyvsp[-1].symbol;
			}
			else
			    yyvsp[-1].symbol = 0;
		    }
break;
case 117:
#line 812 "gram.y"
{	
			yyval.symbol = ParseNewSymbol (yyvsp[-1].fulltype.publish,
					     yyvsp[-1].fulltype.class,
					     yyvsp[-1].fulltype.type,
					     yyvsp[0].atom);
		    }
break;
case 118:
#line 824 "gram.y"
{ yyval.fulltype = yyvsp[-3].fulltype; }
break;
case 119:
#line 830 "gram.y"
{
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc (yyvsp[-3].funcDecl.type.type, yyvsp[-1].argType);
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, yyvsp[-3].funcDecl.decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    yyvsp[-3].funcDecl.decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].funcDecl.type.publish,
						     yyvsp[-3].funcDecl.type.class, 
						     type,
						     yyvsp[-3].funcDecl.decl->name);
			}
			CurrentNamespace = save;
			yyval.funcDecl = yyvsp[-3].funcDecl;
			yyval.funcDecl.decl->symbol = symbol;
			yyval.funcDecl.type.type = type;
		    }
break;
case 120:
#line 863 "gram.y"
{ yyval.funcDecl.type = yyvsp[-2].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 121:
#line 865 "gram.y"
{ yyval.funcDecl.type = yyvsp[-3].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 122:
#line 867 "gram.y"
{ 
			yyval.funcDecl.type.publish = publish_private;
			yyval.funcDecl.type.class = class_undef;
			yyval.funcDecl.type.type = typePoly;
			yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); 
		    }
break;
case 123:
#line 875 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 124:
#line 877 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 125:
#line 879 "gram.y"
{ yyval.expr = 0; }
break;
case 126:
#line 885 "gram.y"
{ yyval.fulltype.publish = yyvsp[-3].publish; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 127:
#line 887 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 128:
#line 889 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = class_undef; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 129:
#line 895 "gram.y"
{ yyval.type = NewTypeFunc (yyvsp[0].type, yyvsp[-1].argType); }
break;
case 130:
#line 897 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, False); }
break;
case 131:
#line 899 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, True); }
break;
case 132:
#line 901 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, False); }
break;
case 133:
#line 903 "gram.y"
{ yyval.type = NewTypeHash (yyvsp[0].type, yyvsp[-2].type); }
break;
case 134:
#line 905 "gram.y"
{ yyval.type = 0; }
break;
case 135:
#line 908 "gram.y"
{
			Type	*top = yyvsp[0].type;
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = yyvsp[-1].type;
			yyval.type = top;
		    }
break;
case 136:
#line 936 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, True); }
break;
case 137:
#line 938 "gram.y"
{ yyval.type = NewTypeRef (NewTypeRef (yyvsp[0].type, True), True); }
break;
case 138:
#line 940 "gram.y"
{ yyval.type = NewTypeRef (NewTypeRef (yyvsp[0].type, False), False); }
break;
case 139:
#line 942 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, False); }
break;
case 141:
#line 946 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeStruct (st);
		    }
break;
case 142:
#line 972 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeUnion (st, False);
		    }
break;
case 143:
#line 998 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			yyval.type = NewTypeUnion (st, True);
		    }
break;
case 144:
#line 1019 "gram.y"
{ yyval.type = yyvsp[-1].type; }
break;
case 145:
#line 1021 "gram.y"
{ yyval.type = NewTypeName (yyvsp[0].expr, 0); }
break;
case 147:
#line 1025 "gram.y"
{ yyval.type = typePoly; }
break;
case 162:
#line 1043 "gram.y"
{ yyval.expr = 0; }
break;
case 163:
#line 1046 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[-2].expr); }
break;
case 164:
#line 1048 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 165:
#line 1051 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[-2].expr); }
break;
case 166:
#line 1053 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 167:
#line 1056 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 168:
#line 1058 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 169:
#line 1064 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 170:
#line 1066 "gram.y"
{ yyval.memList = 0; }
break;
case 171:
#line 1069 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 172:
#line 1071 "gram.y"
{ yyval.memList = 0; }
break;
case 174:
#line 1078 "gram.y"
{ yyval.class = class_undef; }
break;
case 180:
#line 1087 "gram.y"
{ yyval.publish = publish_private; }
break;
case 185:
#line 1101 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 186:
#line 1103 "gram.y"
{ yyval.argType = 0; }
break;
case 187:
#line 1106 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 188:
#line 1108 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 189:
#line 1111 "gram.y"
{ 
			ParseCanonType (yyvsp[-1].type, False);
			yyval.argDecl.type = yyvsp[-1].type; 
			yyval.argDecl.name = yyvsp[0].atom; 
		    }
break;
case 190:
#line 1117 "gram.y"
{ 
			ParseCanonType (yyvsp[0].type, False);
			yyval.argDecl.type = yyvsp[0].type;
			yyval.argDecl.name = 0; 
		    }
break;
case 191:
#line 1128 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 192:
#line 1131 "gram.y"
{
			ArgType	*args;
			Type	*type;

			for (args = yyvsp[0].argType; args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0),
						     False);
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			yyval.argType = yyvsp[0].argType;
		    }
break;
case 193:
#line 1156 "gram.y"
{ yyval.argType = 0; }
break;
case 194:
#line 1159 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 195:
#line 1161 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 196:
#line 1164 "gram.y"
{ yyval.argDecl.type = yyvsp[-1].type; yyval.argDecl.name = yyvsp[0].atom; }
break;
case 197:
#line 1166 "gram.y"
{ yyval.argDecl.type = yyvsp[0].type; yyval.argDecl.name = 0; }
break;
case 198:
#line 1169 "gram.y"
{ yyval.bool = True; }
break;
case 199:
#line 1171 "gram.y"
{ yyval.bool = False; }
break;
case 201:
#line 1179 "gram.y"
{ yyval.expr = 0; }
break;
case 203:
#line 1183 "gram.y"
{ 
			DeclList    *decl;

			for (decl = yyvsp[0].declList; decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = yyvsp[-1].fulltype.type;
			    }
			}

			yyval.expr = NewExprDecl (VAR, yyvsp[0].declList, yyvsp[-1].fulltype.class, yyvsp[-1].fulltype.type, yyvsp[-1].fulltype.publish); 
		    }
break;
case 205:
#line 1200 "gram.y"
{ yyval.expr = NewExprTree(COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 207:
#line 1207 "gram.y"
{ yyval.expr = 0; }
break;
case 208:
#line 1210 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 209:
#line 1212 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 211:
#line 1216 "gram.y"
{ yyval.expr = 0; }
break;
case 212:
#line 1219 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 213:
#line 1221 "gram.y"
{	
			ExprPtr	arg = yyvsp[0].bool ? NewExprTree (DOTDOTDOT, yyvsp[-1].expr, 0) : yyvsp[-1].expr;
			yyval.expr = NewExprTree (COMMA, arg, 0); 
		    }
break;
case 214:
#line 1227 "gram.y"
{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yyvsp[0].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 215:
#line 1232 "gram.y"
{ ++funcDepth; }
break;
case 216:
#line 1232 "gram.y"
{ --funcDepth; yyval.expr = yyvsp[0].expr; }
break;
case 217:
#line 1238 "gram.y"
{ 
			if (yyvsp[-1].ints == ASSIGNPOW)
			    yyval.expr = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, yyvsp[-2].expr, yyvsp[0].expr));
			else
			{
			    ExprPtr left = yyvsp[-2].expr;
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if (yyvsp[-1].ints == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				yyvsp[-2].expr->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  yyvsp[-2].expr->atom.atom);
			    }
			    yyval.expr = NewExprTree(yyvsp[-1].ints, yyvsp[-2].expr, yyvsp[0].expr); 
			}
		    }
break;
case 218:
#line 1264 "gram.y"
{
			ParseCanonType (yyvsp[-6].type, False);
			yyval.expr = NewExprCode (NewFuncCode (yyvsp[-6].type, yyvsp[-3].argType, yyvsp[-1].expr, yyvsp[-2].value), 0); 
		    }
break;
case 219:
#line 1269 "gram.y"
{   Value	t;
			t = do_Thread_id_to_thread (yyvsp[0].value);
			if (t == Void)
			{
			    ParseError ("No thread %v", yyvsp[0].value);
			    YYERROR;
			}
			else
			    yyval.expr = NewExprConst(THREAD_CONST, t); 
		    }
break;
case 220:
#line 1280 "gram.y"
{ yyval.expr = NewExprTree(STAR, yyvsp[0].expr, (Expr *) 0); }
break;
case 221:
#line 1282 "gram.y"
{ yyval.expr = NewExprTree(STAR, NewExprTree (STAR, yyvsp[0].expr, 0), 0); }
break;
case 222:
#line 1284 "gram.y"
{ yyval.expr = NewExprTree(AMPER, yyvsp[0].expr, (Expr *) 0); }
break;
case 223:
#line 1286 "gram.y"
{ yyval.expr = NewExprTree(AMPER, 
				       NewExprTree (AMPER, yyvsp[0].expr, (Expr *) 0), 
				       (Expr *) 0); }
break;
case 224:
#line 1290 "gram.y"
{ yyval.expr = NewExprTree(UMINUS, yyvsp[0].expr, (Expr *) 0); }
break;
case 225:
#line 1292 "gram.y"
{ yyval.expr = NewExprTree(LNOT, yyvsp[0].expr, (Expr *) 0); }
break;
case 226:
#line 1294 "gram.y"
{ yyval.expr = NewExprTree(BANG, yyvsp[0].expr, (Expr *) 0); }
break;
case 227:
#line 1296 "gram.y"
{ yyval.expr = NewExprTree(FACT, yyvsp[-1].expr, (Expr *) 0); }
break;
case 228:
#line 1298 "gram.y"
{ yyval.expr = NewExprTree(INC, yyvsp[0].expr, (Expr *) 0); }
break;
case 229:
#line 1300 "gram.y"
{ yyval.expr = NewExprTree(INC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 230:
#line 1302 "gram.y"
{ yyval.expr = NewExprTree(DEC, yyvsp[0].expr, (Expr *) 0); }
break;
case 231:
#line 1304 "gram.y"
{ yyval.expr = NewExprTree(DEC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 232:
#line 1306 "gram.y"
{ yyval.expr = NewExprTree (FORK, (Expr *) 0, yyvsp[0].expr); }
break;
case 233:
#line 1308 "gram.y"
{ yyval.expr = NewExprTree(PLUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 234:
#line 1310 "gram.y"
{ yyval.expr = NewExprTree(MINUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 235:
#line 1312 "gram.y"
{ yyval.expr = NewExprTree(TIMES, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 236:
#line 1314 "gram.y"
{ yyval.expr = NewExprTree(DIVIDE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 237:
#line 1316 "gram.y"
{ yyval.expr = NewExprTree(DIV, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 238:
#line 1318 "gram.y"
{ yyval.expr = NewExprTree(MOD, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 239:
#line 1320 "gram.y"
{ 
			yyval.expr = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, yyvsp[-2].expr, yyvsp[0].expr)); 
		    }
break;
case 240:
#line 1326 "gram.y"
{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yyvsp[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(2))));
		    }
break;
case 241:
#line 1334 "gram.y"
{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yyvsp[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(3))));
		    }
break;
case 242:
#line 1342 "gram.y"
{ yyval.expr = NewExprTree(SHIFTL, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 243:
#line 1344 "gram.y"
{ yyval.expr = NewExprTree(SHIFTR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 244:
#line 1346 "gram.y"
{ yyval.expr = NewExprTree(QUEST, yyvsp[-4].expr, NewExprTree(COLON, yyvsp[-2].expr, yyvsp[0].expr)); }
break;
case 245:
#line 1348 "gram.y"
{ yyval.expr = NewExprTree(LXOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 246:
#line 1350 "gram.y"
{ yyval.expr = NewExprTree(LAND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 247:
#line 1352 "gram.y"
{ yyval.expr = NewExprTree(LOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 248:
#line 1354 "gram.y"
{ yyval.expr = NewExprTree(AND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 249:
#line 1356 "gram.y"
{ yyval.expr = NewExprTree(OR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 250:
#line 1358 "gram.y"
{ yyval.expr = NewExprTree(EQ, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 251:
#line 1360 "gram.y"
{ yyval.expr = NewExprTree(NE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 252:
#line 1362 "gram.y"
{ yyval.expr = NewExprTree(LT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 253:
#line 1364 "gram.y"
{ yyval.expr = NewExprTree(GT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 254:
#line 1366 "gram.y"
{ yyval.expr = NewExprTree(LE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 255:
#line 1368 "gram.y"
{ yyval.expr = NewExprTree(GE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 257:
#line 1371 "gram.y"
{ yyval.expr = NewExprConst(TEN_NUM, yyvsp[0].value); }
break;
case 258:
#line 1373 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_NUM, yyvsp[0].value); }
break;
case 259:
#line 1375 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_NUM, yyvsp[0].value); }
break;
case 260:
#line 1377 "gram.y"
{ yyval.expr = NewExprConst(BINARY_NUM, yyvsp[0].value); }
break;
case 261:
#line 1379 "gram.y"
{ yyval.expr = NewExprConst(HEX_NUM, yyvsp[0].value); }
break;
case 262:
#line 1381 "gram.y"
{ yyval.expr = NewExprConst(TEN_FLOAT, yyvsp[0].value); }
break;
case 263:
#line 1383 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_FLOAT, yyvsp[0].value); }
break;
case 264:
#line 1385 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_FLOAT, yyvsp[0].value); }
break;
case 265:
#line 1387 "gram.y"
{ yyval.expr = NewExprConst(BINARY_FLOAT, yyvsp[0].value); }
break;
case 266:
#line 1389 "gram.y"
{ yyval.expr = NewExprConst(HEX_FLOAT, yyvsp[0].value); }
break;
case 267:
#line 1391 "gram.y"
{ yyval.expr = NewExprConst(CHAR_CONST, yyvsp[0].value); }
break;
case 268:
#line 1393 "gram.y"
{ yyval.expr = NewExprConst(STRING_CONST, yyvsp[0].value); }
break;
case 269:
#line 1395 "gram.y"
{ yyval.expr = NewExprConst(VOIDVAL, yyvsp[0].value); }
break;
case 270:
#line 1397 "gram.y"
{ yyval.expr = NewExprConst(BOOLVAL, yyvsp[0].value); }
break;
case 271:
#line 1399 "gram.y"
{ 
			yyval.expr = BuildFullname (0, AtomId ("[]"));
		    }
break;
case 272:
#line 1403 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = yyvsp[-4].type;
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 273:
#line 1411 "gram.y"
{ 
			yyvsp[-1].expr->base.type = NewTypeArray (typePoly, yyvsp[-5].expr, True); 
			ParseCanonType (yyvsp[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			yyval.expr->base.type = yyvsp[-1].expr->base.type;
		    }
break;
case 274:
#line 1418 "gram.y"
{ 
			TypePtr	t = NewTypeArray (typePoly, yyvsp[-5].expr, False);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 275:
#line 1427 "gram.y"
{
			TypePtr t = NewTypeHash (typePoly, yyvsp[-5].type);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 276:
#line 1436 "gram.y"
{
			ParseCanonType (yyvsp[-2].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[0].atom, 0, False), 0); 
			yyval.expr->base.type = yyvsp[-2].type;
		    }
break;
case 277:
#line 1442 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); 
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 278:
#line 1448 "gram.y"
{ yyval.expr = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, yyvsp[0].value)); }
break;
case 279:
#line 1450 "gram.y"
{ yyval.expr = NewExprTree (DOLLAR, 0, 0); }
break;
case 280:
#line 1452 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 281:
#line 1454 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 282:
#line 1456 "gram.y"
{ yyval.expr = NewExprTree (OS, NewExprTree (STAR, yyvsp[-3].expr, (Expr *) 0), yyvsp[-1].expr); }
break;
case 283:
#line 1458 "gram.y"
{ yyval.expr = NewExprTree(OS, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 284:
#line 1460 "gram.y"
{ yyval.expr = NewExprTree (OP, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 285:
#line 1462 "gram.y"
{ yyval.expr = NewExprTree(DOT, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 286:
#line 1464 "gram.y"
{ yyval.expr = NewExprTree(ARROW, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 288:
#line 1468 "gram.y"
{ yyval.value = Zero; }
break;
case 308:
#line 1494 "gram.y"
{ yyval.expr = 0; }
break;
case 309:
#line 1496 "gram.y"
{ yyval.expr = 0; }
break;
case 310:
#line 1499 "gram.y"
{ 
			ExprPtr	elts = yyvsp[-3].expr ? ExprRehang (yyvsp[-3].expr, 0) : 0;
			if (yyvsp[-1].bool)
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTDOTDOT, 0, 0),
							 0);
			}
			yyval.expr = NewExprTree (ARRAY, elts, 0); 
		    }
break;
case 311:
#line 1513 "gram.y"
{
			yyval.expr = NewExprTree (COMP, NewExprTree (COMP, yyvsp[-5].expr, yyvsp[-4].expr), yyvsp[-2].expr);
		    }
break;
case 312:
#line 1518 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 314:
#line 1522 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 316:
#line 1526 "gram.y"
{ 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], yyvsp[0].atom);
			yyval.expr = NewExprAtom (yyvsp[0].atom, s, False); 
		    }
break;
case 317:
#line 1534 "gram.y"
{
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			yyval.expr = NewExprAtom (a, s, False);
		    }
break;
case 318:
#line 1543 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 319:
#line 1545 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 323:
#line 1556 "gram.y"
{ yyval.expr = 0; }
break;
case 324:
#line 1558 "gram.y"
{ yyval.expr = 0; }
break;
case 325:
#line 1561 "gram.y"
{
			ExprPtr elts = yyvsp[-2].expr ? ExprRehang (yyvsp[-2].expr, 0) : 0;
			yyval.expr = NewExprTree (HASH, elts, 0);
		    }
break;
case 326:
#line 1567 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 327:
#line 1569 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 328:
#line 1572 "gram.y"
{ yyval.expr = NewExprTree (DARROW, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 329:
#line 1574 "gram.y"
{ yyval.expr = NewExprTree (DARROW, 0, yyvsp[0].expr); }
break;
case 332:
#line 1583 "gram.y"
{ yyval.expr = NewExprTree (STRUCT, ExprRehang (yyvsp[-2].expr, 0), 0); }
break;
case 333:
#line 1586 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 334:
#line 1588 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 335:
#line 1591 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 336:
#line 1593 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 340:
#line 1600 "gram.y"
{ yyval.expr = NewExprTree (ANONINIT, 0, 0); }
break;
#line 4684 "gram.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
